#include <     amxmodx                          >
#include <     amxmisc                          >
#include <     cstrike                          >
#include <     hamsandwich                      >
#include <     fakemeta                         >
#include <     fun                              >
#include <     engine                           >
#include <     cs_battleroyale_faketeams        >
#include <     cs_battleroyale_roundmanager     >
#include <     orpheu                           >
#include <     orpheu_stocks                    >
#include <     orpheu_advanced                  >
#include <     csbr_config                      >

#define HIDE_ROUND_TIMER ( 1<<4 )
#define HIDE_MONEY       ( 1<<5 )

#if AMXX_VERSION_NUM < 183
#include < dhudmessage >
#endif

#if !defined CSW_GLOCK
#define CSW_GLOCK 2
#endif

//#define DUMP_ORIGIN_DATA

#define USE_CUSTOM_SPAWN_POINTS
//#define USE_AUTOMATIC_SPAWN_POINTS

#define ADD_FLAG ADMIN_RCON

#if defined USE_AUTOMATIC_SPAWN_POINTS
#include <     rog                              >
#endif

enum
{
	VIEW_NONE,
	VIEW_3RDPERSON
};

enum ( += 97643 )
{
	TASK_PARACHUTE_DEPLOY,
	TASK_AIRDROP,
	TASK_AIRDROP_AFK,
	TASK_SHOW_MSG_AIRPLANE
};

enum 
{
	deploy,
	idle,
	detach
};

enum _:AirDropData
{
	AirDrop_Model_Flying[ 128 ],
	AirDrop_Model_Ground[ 128 ]
};

enum _:AirPlaneData
{
	AirPlane_Model[ 128 ]
};

enum _:Config
{
	AIRDROP_CLASSNAME[ 64 ],
	AIRPLANE_CLASSNAME[ 64 ],
	GAME_SOUNDS_FILE[ 64 ],
	GAME_MODELS_FILE[ 64 ],
	GAME_WEAPONS_FILE[ 64 ],
	PLANE_ORIGINS_FILE[ 64 ],
	GAME_CUSTOM_SPAWN_POINTS_FILE[ 64 ],
	ARROW_ICON_SPRITE[ 64 ],
	AUTO_POINTS_FILE[ 64 ],
	ZONE_ORIGINS_FILE[ 64 ]
};

enum
{
	RARITY_GREY = 1,
	RARITY_GREEN,
	RARITY_BLUE,
	RARITY_PURPLE,
	RARITY_GOLD
};

enum _:WeaponData
{
	Weapon_Name[ 32 ],
	Weapon_Rarity
};

enum _:SoundEffects
{
	Parachute_Deploy_Sound[ 128 ],
	Landing_Sound[ 128 ],
	AirDrop_Appear_Sound[ 128 ],
	AirDrop_Land_Sound[ 128 ]
};

enum _:AmmoIndexData
{
	AmmoIndex,
	AmmoCount
};

enum _:SpawnPointsData
{
Float:SP_Axis[ 3 ]
};

enum _:PlaneData
{
Float:PlaneOrigin[ 3 ],
Float:PlaneAngle[ 3 ],
Float:PlaneVelocity[ 3 ]
};

new g_szMapName[ 32 ];
new g_szConfigsDir[ 128 ];

new g_iSprite;
new g_iAirDrops;
new g_iSpriteIndexExplosion;
new g_iAirPlaneEnt;
new g_iDummyResult;
new g_iMsgHideWeapon;

new g_iFwOpenAirDrop;
new g_iFwJumpPlane;
new g_iFwUrgentJumpPlane;
new g_iFwDeployParachute;

new Float:g_fCachedParachuteVelocity;
new Float:g_fCachedAirDropVelocity;
new Float:g_fMinimumSpawnPoint;

new IntClassNameString;
new OrpheuFunction:HandleCreateNamedEntityFunc;
new OrpheuFunction:HandlePackWeaponFunc;
new CWeaponBoxKill_Address;

new g_iDataAirDrop[ AirDropData ];
new g_iDataAirPlane[ AirPlaneData ];
new g_iSounds[ SoundEffects ];
new g_iConfig[ Config ];
new g_eAmmoIndex[ 31 ][ AmmoIndexData ];

new g_iPlayerView[ 33 ];
new g_iCvars[ 11 ];
new g_iAmmoNames[ 16 ];

new bool:g_bPlayerInPlane[ 33 ];
new bool:g_bIsPlayerInParachute[ 33 ];
new bool:g_bLandedPlayer[ 33 ];

#if defined USE_CUSTOM_SPAWN_POINTS
new const g_szAddNewSpawnPointsCmd[ ][ ] =
{
	"say /spawn_points",
	"say_team /spawn_points",
	"say /sp",
	"say_team /sp"
};
#endif

new const g_szPlaneDirectionsCmd[ ][ ] =
{
	"say /plane_directions",
	"say /pd"
};

new const g_szObjectiveEnts[ ][ ] =
{
	"func_bomb_target",
	"info_bomb_target",
	"hostage_entity",
	"monster_scientist",
	"func_hostage_rescue",
	"info_hostage_rescue",
	"info_vip_start",
	"func_vip_safetyzone",
	"func_escapezone"
};

new const g_szRarityValues[ ][ ] =
{
	"RARITY_GREY",
	"RARITY_GREEN",
	"RARITY_BLUE",
	"RARITY_PURPLE",
	"RARITY_GOLD"
};

new const g_iRarityValues[ ] =
{
	RARITY_GREY,
	RARITY_GREEN,
	RARITY_BLUE,
	RARITY_PURPLE,
	RARITY_GOLD
};

new const g_szWeaponIds[ ][ ] =
{
	"CSW_P228", "", "CSW_SCOUT", "CSW_HEGRENADE", "CSW_XM1014", "", "CSW_MAC10", "CSW_AUG", "CSW_SMOKEGRENADE", "CSW_ELITE", "CSW_FIVESEVEN", "CSW_UMP45", "CSW_SG550", "CSW_GALIL",
	"CSW_FAMAS", "CSW_USP", "CSW_GLOCK18", "CSW_AWP", "CSW_MP5NAVY", "CSW_M249", "CSW_M3", "CSW_M4A1", "CSW_TMP", "CSW_G3SG1", "CSW_FLASHBANG", "CSW_DEAGLE", "CSW_SG552", "CSW_AK47", "", "CSW_P90"
};

new const g_iWeaponIds[ ] =
{
	CSW_P228, CSW_GLOCK, CSW_SCOUT, CSW_HEGRENADE, CSW_XM1014, CSW_C4, CSW_MAC10, CSW_AUG, CSW_SMOKEGRENADE, CSW_ELITE, CSW_FIVESEVEN, CSW_UMP45, CSW_SG550, CSW_GALIL, CSW_FAMAS, 
	CSW_USP, CSW_GLOCK18, CSW_AWP, CSW_MP5NAVY, CSW_M249, CSW_M3, CSW_M4A1, CSW_TMP, CSW_G3SG1, CSW_FLASHBANG, CSW_DEAGLE, CSW_SG552, CSW_AK47, CSW_KNIFE, CSW_P90
};

new Array:g_aWeaponData;
new Array:g_aPlaneDirections;
new Array:g_aAirDropWeapons;

new Trie:g_tRarityTrie;
new Trie:g_tWeaponIds;

#if defined USE_CUSTOM_SPAWN_POINTS
new Array:g_aCustomSpawnPoints;
#endif

new const g_szWeaponBoxModels[ ][ ] = 
{ 
	"", "models/w_p228.mdl",  "", 
	"models/w_scout.mdl",  "models/w_hegrenade.mdl", "models/w_xm1014.mdl", 
	"", "models/w_mac10.mdl", "models/w_aug.mdl", "models/w_smokegrenade.mdl", 
	"models/w_elite.mdl", "models/w_fiveseven.mdl",  "models/w_ump45.mdl",  
	"models/w_sg550.mdl", "models/w_galil.mdl",  "models/w_famas.mdl",  
	"models/w_usp.mdl", "models/w_glock18.mdl", "models/w_awp.mdl",  
	"models/w_mp5.mdl", "models/w_m249.mdl",  "models/w_m3.mdl", 
	"models/w_m4a1.mdl", "models/w_tmp.mdl", "models/w_g3sg1.mdl",  
	"models/w_flashbang.mdl", "models/w_deagle.mdl", "models/w_sg552.mdl", "models/w_ak47.mdl", 
	"", "models/w_p90.mdl",  "", "" 
};

new const g_szForbiddenWeapons[ ][ ] =
{
	"weapon_c4",
	"weapon_glock",
	"weapon_knife",
	"weapon_kevlar"
};

new const m_rgpPlayerItems_CWeaponBox[ 6 ] = { 34, 35, ... }; 

new const g_szStringAmmoNames[ ][ ] = 
{
	"", 
	"338Magnum", 
	"762Nato",
	"556NatoBox", 
	"556Nato",
	"buckshot", 
	"45ACP", 
	"57mm", 
	"50AE", 
	"357SIG",
	"9mm", 
	"Flashbang",
	"HEGrenade", 
	"SmokeGrenade", 
	"C4"
};

new g_pGameRules;

new OrpheuFunction:HandlePackAmmoFunc;

const XO_CWEAPONBOX = 4;
const m_iId = 43;
const m_pfnThink =  4;
const m_iType = 34;
const m_iCount = 35;
const m_bHasPrimary = 116;
const m_pActiveItem  = 373;

public plugin_init( )
{
	register_plugin( "CS Battle Royale Core", VERSION, "DoNii" );
	
	register_dictionary( "cs_battleroyale.txt" );
	
	// cvars
	g_iCvars[ 0 ]  =  register_cvar( "csbr_parachute_deploy_time", "1.0" );      // time to deploy parachute after spawning (seconds)
	g_iCvars[ 1 ]  =  register_cvar( "csbr_parachute_fall_speed", "-250.0" );    // player parachute fall speed
	g_iCvars[ 2 ]  =  register_cvar( "csbr_camera_switch", "1" );                // allow camera switch
	g_iCvars[ 3 ]  =  register_cvar( "csbr_airdrop_freq_min", "15.0" );          // minimum time of an airdrop
	g_iCvars[ 4 ]  =  register_cvar( "csbr_airdrop_freq_max", "30.0" );          // maximum time of an airdrop, ex: 180.0, 360.0 --> random_float(180.0, 360.0)
	g_iCvars[ 5 ]  =  register_cvar( "csbr_airdrop_count", "3" );                // number of airdrops in 1 round
	g_iCvars[ 6 ]  =  register_cvar( "csbr_airdrop_velocity", "-50.0" );         // airdrop fall velocity
	g_iCvars[ 7 ]  =  register_cvar( "csbr_airdrop_open_distance", "100.0" );    // distance to allow opening of airdrop
	g_iCvars[ 8 ]  =  register_cvar( "csbr_airplane_disappear_time", "20.0" );   // time task for the airplane to disappear
	g_iCvars[ 9 ]  =  register_cvar( "csbr_glow_extra_damage", "2" );            // extra damage to give to each glow
	g_iCvars[ 10 ] =  register_cvar( "csbr_distance_between_points", "250.0" );  // minimum distance inbetween 2 spawn points
	
	register_cvar( "cs_battleroyale_version", VERSION, FCVAR_SERVER | FCVAR_SPONLY | FCVAR_UNLOGGED );
	
	g_iMsgHideWeapon = get_user_msgid( "HideWeapon" );
	
	register_message( g_iMsgHideWeapon, "MsgHideWeapon" );
	register_event( "ResetHUD", "OnResetHUD", "b" );
	
	set_msg_block( get_user_msgid( "RoundTime" ), BLOCK_SET ); // Block round time
	set_msg_block( get_user_msgid( "ClCorpse" ), BLOCK_SET ); // Block ClCorpse, so dead bodies are removed
	set_msg_block( get_user_msgid( "Radar" ), BLOCK_SET ); // Block radar, we don't want players looking at it
	
	OrpheuRegisterHookFromObject( g_pGameRules, "GiveC4", "CGameRules", "CGameRules_OnGiveC4" );
	OrpheuRegisterHookFromObject( g_pGameRules, "CheckWinConditions", "CGameRules", "CGameRules_CheckWinConditions" );
	
	#if defined USE_AUTOMATIC_SPAWN_POINTS
	ROGInitialize( get_pcvar_float( g_iCvars[ 10 ] ), "CheckOrigin" );
	
	#if defined DUMP_ORIGIN_DATA
	ROGDumpOriginData( );
	#endif
	#endif
	
	register_message( get_user_msgid( "StatusIcon" ), "OnMessageStatusIcon" ); // Hook StatusIcon
	
	// Orpheu
	IntClassNameString = engfunc( EngFunc_AllocString, "weaponbox" ); // Allocate weaponbox ent
	
	HandleCreateNamedEntityFunc = OrpheuGetFunction( "CREATE_NAMED_ENTITY" );
	HandlePackWeaponFunc = OrpheuGetFunction( "PackWeapon", "CWeaponBox" );
	
	CWeaponBoxKill_Address = OrpheuGetFunctionAddress( OrpheuGetFunction( "Kill", "CWeaponBox" ) );
	HandlePackAmmoFunc = OrpheuGetFunction( "PackAmmo", "CWeaponBox" );
	
	// register_logevent FORWARDS
	register_logevent( "OnNewRound", 2, "1=Round_Start" ); // hook new round
	
	new i;
	// register_clcmd
	#if defined USE_CUSTOM_SPAWN_POINTS
	for( i = 0; i < sizeof g_szAddNewSpawnPointsCmd; i++ )
	{
		register_clcmd( g_szAddNewSpawnPointsCmd[ i ], "OnSpawnPointsMenu" );
	}
	#endif
	
	for( i = 0; i < sizeof g_szPlaneDirectionsCmd; i++ )
	{
		register_clcmd( g_szPlaneDirectionsCmd[ i ], "OnPlaneDirectionsMenu" );
	}
	
	// HAM FORWARDS
	RegisterHam( Ham_TakeDamage, "player", "@HamTakeDamage_Pre", 0 );
	RegisterHam( Ham_Player_ImpulseCommands, "player", "@HamPlayerImpulseCommands_Pre", 0 );
	RegisterHam( Ham_Player_Jump, "player", "@HamPlayerJump_Post", 1 );
	RegisterHam( Ham_Spawn, "player", "@HamSpawn_Post", 1 );
	
	// FM FORWARDS	
	register_forward( FM_CmdStart, "@CmdStart" );
	register_forward( FM_SetModel, "@SetModel" );
	register_forward( FM_AddToFullPack, "@AddToFullPack_Post", 1 );
	register_forward( FM_Voice_SetClientListening, "@SetClientListening" );
	
	// Engine FORWARDS
	register_think( g_iConfig[ AIRDROP_CLASSNAME ], "@AirDropThink" ); // make airdrop think
	
	// Remove Armoury
	remove_entity_name( "armoury_entity" ); // remove all armoury_entity in the map
	
	g_iFwOpenAirDrop       =   CreateMultiForward( "PlayerOpenAirDrop",     ET_IGNORE, FP_CELL, FP_CELL );
	g_iFwJumpPlane         =   CreateMultiForward( "PlayerJumpPlane",       ET_IGNORE, FP_CELL          );
	g_iFwUrgentJumpPlane   =   CreateMultiForward( "PlayerUrgentJump",      ET_IGNORE, FP_CELL          );
	g_iFwDeployParachute   =   CreateMultiForward( "PlayerDeployParachute", ET_IGNORE, FP_CELL          );
}

public plugin_precache( )
{
	get_mapname( g_szMapName, charsmax( g_szMapName ) ); // cache it so we don't retrieve the same thing alot of times
	get_configsdir( g_szConfigsDir, charsmax( g_szConfigsDir ) ); // same as above

	OrpheuRegisterHook( OrpheuGetFunction( "InstallGameRules" ), "OnInstallGameRules", OrpheuHookPost );

	register_forward( FM_Spawn, "@FM_Spawn" );
	
	g_aAirDropWeapons = ArrayCreate( 1 );
	g_aWeaponData = ArrayCreate( WeaponData ); // create array for weapons
	g_aPlaneDirections = ArrayCreate( PlaneData ); // create array to hold plane directions
	
	g_tRarityTrie = TrieCreate( ); // create trie -> int map for Rarity IDs
	g_tWeaponIds = TrieCreate( ); // create trie -> int map for CSW IDs
	
	#if defined USE_CUSTOM_SPAWN_POINTS
	g_aCustomSpawnPoints = ArrayCreate( SpawnPointsData );
	#endif
	
	RegisterWeaponList( .id = get_user_msgid( "WeaponList" ) );
	
	new i;
	for( i = 0; i < sizeof g_szRarityValues; i++ )
	{
		TrieSetCell( g_tRarityTrie, g_szRarityValues[ i ], g_iRarityValues[ i ] ); // assign int values to trie
	}
	
	for( i = 0; i < sizeof g_szWeaponIds; i++ )
	{
		if( g_szWeaponIds[ i ][ 0 ] )
		TrieSetCell( g_tWeaponIds, g_szWeaponIds[ i ], g_iWeaponIds[ i ] );
	}
	
	for( i = 1; i < sizeof g_szStringAmmoNames; i++)
	{
		g_iAmmoNames[ i ] = engfunc( EngFunc_AllocString, g_szStringAmmoNames[ i ] ); // allocate ammo names
	}
	
	ReadConfig( ); // read config
	ReadModels( ); // read our models
	ReadSounds( ); // read our sounds
	ReadWeapons( ); // read our weapons
	ReadPlaneOrigins( ); // read the plane origins
	
	#if defined USE_AUTOMATIC_SPAWN_POINTS
	ReadMinimumPoint( ); // read the minimum spawning point
	
	#else
	ReadSpawnPoints( );
	#endif
	
	CheckDirectory( ); // check if the folder for this map exists
	
	precache_model( "models/rpgrocket.mdl" ); // needed for camera view, server will crash without precaching it	
	
	g_iSpriteIndexExplosion = precache_model( "sprites/zerogxplode.spr" ); // airdrop explosion effect
	g_iSprite = precache_model( g_iConfig[ ARROW_ICON_SPRITE ] ); // arrow icon to show on teammates head
}

public @FM_Spawn( iEnt )
{
	if( ! pev_valid( iEnt ) )
	return FMRES_IGNORED;

	static szClassName[ 32 ], i;
	pev( iEnt, pev_classname, szClassName, charsmax( szClassName ) );
	
	for( i = 0; i < sizeof g_szObjectiveEnts; ++i )
	{
		if( equal( szClassName, g_szObjectiveEnts[ i ] ) )
		{
			engfunc( EngFunc_RemoveEntity, iEnt );
			return FMRES_SUPERCEDE;
		}
	}
	return FMRES_IGNORED;
}

public OnInstallGameRules( )
{
	g_pGameRules = OrpheuGetReturn( );
}

public OrpheuHookReturn:CGameRules_OnGiveC4( g_pGameRules, id )
{
	return OrpheuSupercede;
}

public OrpheuHookReturn:CGameRules_CheckWinConditions( ) 
{
	return OrpheuSupercede;
}

@SetClientListening( iReceiver, iSender, bool:bListen )
{
	if( GetPlayerTeam( iReceiver ) != GetPlayerTeam( iSender ) )
	{
		engfunc( EngFunc_SetClientListening, iReceiver, iSender, false );
		forward_return( FMV_CELL, false );
		
		return FMRES_SUPERCEDE;
	}
	return FMRES_IGNORED;
}

#if defined USE_CUSTOM_SPAWN_POINTS
public OnSpawnPointsMenu( id )
{
	if( ~ get_user_flags( id ) & ADD_FLAG )
	return PLUGIN_HANDLED;
	
	new iMenu = menu_create( "Menu to add new spawn points", "OnSpawnPointsMenu_Handler" );
	
	new szItem[ 64 ], Float:fOrigin[ 3 ];
	pev( id, pev_origin, fOrigin );
	formatex( szItem, charsmax( szItem ), "Add Current Location (%.1f %.1f %.1f)", fOrigin[ 0 ], fOrigin[ 1 ], fOrigin[ 2 ] );
	
	menu_additem( iMenu, szItem, _, _ );
	menu_setprop( iMenu, MPROP_EXIT, MEXIT_ALL );
	
	menu_display( id, iMenu, 0 );
	return PLUGIN_CONTINUE;
}

public OnSpawnPointsMenu_Handler( id, iMenu, iItem )
{
	if( iItem == 0 )
	{
		new Float:fOrigin[ 3 ], szOrigin[ 32 ];
		pev( id, pev_origin, fOrigin );

		formatex( szOrigin, charsmax( szOrigin ), "%.1f %.1f %.1f", fOrigin[ 0 ], fOrigin[ 1 ], fOrigin[ 2 ] );
		
		if( WriteToFile( szOrigin ) == -1 )
		{
			log_amx( "[CSBR] File to write new custom points not found" );
			return PLUGIN_HANDLED;
		}
	}
	menu_destroy( iMenu );
	return PLUGIN_HANDLED;
}
#endif

public OnPlaneDirectionsMenu( id )
{
	if( ~ get_user_flags( id ) & ADD_FLAG )
	return PLUGIN_HANDLED;
	
	new iMenu = menu_create( "Menu to add Plane Directions", "OnPlaneDirectionsMenu_Handler" );
	
	new szItem[ 64 ], Float:fOrigin[ 3 ];
	pev( id, pev_origin, fOrigin );
	formatex( szItem, charsmax( szItem ), "Add Direction" );
	
	menu_additem( iMenu, szItem, _, _ );
	menu_setprop( iMenu, MPROP_EXIT, MEXIT_ALL );
	
	menu_display( id, iMenu, 0 );
	return PLUGIN_CONTINUE;
}

public OnPlaneDirectionsMenu_Handler( id, iMenu, iItem )
{
	if( iItem == 0 )
	{
		new szDirection[ 128 ];
		new Float:fOrigin[ 3 ], Float:fAngle[ 3 ], Float:fVelocity[ 3 ];
		
		pev( id, pev_origin, fOrigin );
		pev( id, pev_angles, fAngle );
		velocity_by_aim( id, 300, fVelocity );
		
		formatex( szDirection, charsmax( szDirection ), "%.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f", fOrigin[ 0 ], fOrigin[ 1 ], fOrigin[ 2 ], fAngle[ 0 ], fAngle[ 1 ], fAngle[ 2 ], fVelocity[ 0 ], fVelocity[ 1 ], fVelocity[ 2 ] );
		
		if( WritePlaneDirectionToFile( szDirection ) == -1 )
		{
			log_amx( "[CSBR] File to write plane direction not found" );
			return PLUGIN_HANDLED;
		}
	}
	menu_destroy( iMenu );
	return PLUGIN_HANDLED;
}

public MsgHideWeapon( )
{
	set_msg_arg_int( 1, ARG_BYTE, get_msg_arg_int( 1 ) | HIDE_ROUND_TIMER | HIDE_MONEY );
}

public OnResetHUD( id )
{
	message_begin( MSG_ONE, g_iMsgHideWeapon, _, id )
	write_byte( HIDE_ROUND_TIMER )
	message_end( )
}

public CheckOrigin( Float:fOrigin[ 3 ] )
{	
	if( g_fMinimumSpawnPoint == 0.0 )
	return 1;

	else
	{
		if( fOrigin[ 2 ] < g_fMinimumSpawnPoint ) // we don't want our entities to be spawned in the under-ground area
		{
			return 0;
		}
	}
	return 1;
}

@RegUserMsg( const szName[ ], const iSize )
{
	if( equal( szName, "WeaponList" ) )
	{
		RegisterWeaponList( .id = get_orig_retval( ) );
	}
}

RegisterWeaponList( const id = 0 )
{
	static iForwardHandle = -1;

	if( ! id )
	{
		iForwardHandle = register_forward( FM_RegUserMsg, "@RegUserMsg", ._post = true );
		return;
	}

	if( iForwardHandle != -1 )
	{
		unregister_forward( FM_RegUserMsg, iForwardHandle, .post = true );
	}

	register_message( id, "@OnMessageWeaponList" );
}

@OnMessageWeaponList( const iMsgId, const iMsgType, const iEnt )
{
	new iAmmoIndex = get_msg_arg_int( 2 ); // get ammo index
	new iAmmoCount = get_msg_arg_int( 3 ); // get ammo count
	new iWeaponID = get_msg_arg_int( 8 );  // get weapon id
	
	g_eAmmoIndex[ iWeaponID ][ AmmoIndex ] = iAmmoIndex; // save ammo index
	g_eAmmoIndex[ iWeaponID ][ AmmoCount ] = iAmmoCount; // save ammo count
}

@HamPlayerJump_Post( id ) // player jump
{
	if( ! g_bPlayerInPlane[ id ] ) // if hes not in airplane, no need to continue
	return HAM_IGNORED;

	remove_task( id + TASK_SHOW_MSG_AIRPLANE );
	
	g_iPlayerView[ id ] = VIEW_NONE;
	set_view( id, VIEW_NONE );
	
	client_cmd( id, "stopsound" );
	
	set_pev( id, pev_movetype, MOVETYPE_TOSS ); // set MOVETYPE_TOSS when hes in the sky
	
	g_bPlayerInPlane[ id ] = false; // player left plane
	g_bIsPlayerInParachute[ id ] = true; // player is in parachute now
	
	set_user_rendering( id ); // reset his rendering (make him visible)
	
	set_pev( id, pev_gravity, DEFAULT_GRAVITY ); // reset his gravity to default
	set_user_maxspeed( id, DEFAULT_MAXSPEED );   // reset his speed to default
	
	set_pev( id, pev_sequence, deploy ); // make new sequence
	
	set_task( get_pcvar_float( g_iCvars[ 0 ] ), "OnDeployParachute", id+TASK_PARACHUTE_DEPLOY ); // task for parachute
	client_cmd( id, "spk sound/%s", g_iSounds[ Parachute_Deploy_Sound ] ); // emit parachute deploy sound
	
	ExecuteForward( g_iFwJumpPlane, g_iDummyResult, id );	
	return HAM_IGNORED;
}

@AddToFullPack_Post( ES_Handle, E, iEnt, iHost, iHostFlags, iPlayer, iSet)
{
	if( ! is_user_alive( iEnt ) || ! is_user_alive( iHost ) )
	return FMRES_IGNORED;
	
	if( GetPlayerTeam( iEnt ) == GetPlayerTeam( iHost ) && ( iEnt != iHost ) ) // check if the player in sight is our teammate and is not the host himself
	{
		message_begin( MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, iHost )
		write_byte( TE_PLAYERATTACHMENT );
		write_byte( iEnt );
		write_coord( 45 );
		write_short( g_iSprite ); 
		write_short( 20 );
		message_end( ); 
	}
	return FMRES_IGNORED;
}  

public OnDeployParachute( id )
{
	id -= TASK_PARACHUTE_DEPLOY;

	g_bIsPlayerInParachute[ id ] = true;
	ExecuteForward( g_iFwDeployParachute, g_iDummyResult, id );
	
	remove_task( id + TASK_PARACHUTE_DEPLOY );
}

@HamSpawn_Post( id )
{
	if( is_user_alive( id ) )
	{
		strip_user_weapons( id ); // remove all weapons
		give_item( id, "weapon_knife" ); // give him a knife, poor guy
		
		set_view( id, CAMERA_NONE ); // set his camera to default
		g_iPlayerView[ id ] = VIEW_NONE; // assign default view to var
		
		g_bLandedPlayer[ id ] = true; // bugfix
	}
	return HAM_IGNORED;
}

public RoundEnded( )
{
	RemoveAllWeaponBox( );

	remove_entity_name( g_iConfig[ AIRDROP_CLASSNAME ] ); // remove all airdrops
	remove_entity_name( g_iConfig[ AIRPLANE_CLASSNAME ] ); // remove airplane
	
	remove_task( TASK_AIRDROP ); // end task airdrop
	
	g_iAirDrops = 0;	
	g_iAirPlaneEnt = 0;
}

public OnNewRound( )
{
	g_fCachedParachuteVelocity = get_pcvar_float( g_iCvars[ 1 ] ); // cache our parachute velocity, we dont wanna retrieve same value every frame
	g_fCachedAirDropVelocity = get_pcvar_float( g_iCvars[ 6 ] ); // same as above

	#if defined USE_AUTOMATIC_SPAWN_POINTS
	ROGShuffleOrigins( ); // randomize our origins
	#endif
	
	RemoveAllWeaponBox( );
	
	remove_entity_name( g_iConfig[ AIRDROP_CLASSNAME ] ); // remove all airdrops
	remove_entity_name( g_iConfig[ AIRPLANE_CLASSNAME ] ); // remove airplane
	
	remove_task( TASK_AIRDROP ); // end task airdrop
	
	g_iAirDrops = 0;	
	g_iAirPlaneEnt = 0;
	
	new szPlayers[ 32 ], iNum, iTempID;
	get_players( szPlayers, iNum, "h" );
	
	for( new i; i < iNum; i++ )
	{
		iTempID = szPlayers[ i ];
		
		remove_task( iTempID + TASK_PARACHUTE_DEPLOY ); // just to make sure
		g_bLandedPlayer[ iTempID ] = false;
	}
	
	return PLUGIN_CONTINUE;
}

public RoundStarted( )
{	
	MakeAirPlane( ); // create airplane
	set_task( get_pcvar_float( g_iCvars[ 8 ] ), "DropAfkPlayers", TASK_AIRDROP_AFK ); // if there's AFK players who forgot to jump, force them to jump
	
	new Float:fOrigin[ 3 ], iArraySize = ArraySize( g_aWeaponData ), eData[ WeaponData ];
	
	for( new i; i < iArraySize; i++ )
	{
		ArrayGetArray( g_aWeaponData, i, eData );
		
		#if defined USE_AUTOMATIC_SPAWN_POINTS
		ROGGetOrigin( fOrigin );
		#else
		if( GetRandomOrigin( fOrigin ) == -1 ) // no origins found
		{
			log_amx( "[CSBR] No Custom Origins Found" );
			break;
		}
		#endif
		
		OrpheuCreateWeaponBox( eData[ Weapon_Name ], eData[ Weapon_Rarity ], fOrigin );
	}
	new Float:fTimeAirDrop = random_float( get_pcvar_float( g_iCvars[ 3 ] ), get_pcvar_float( g_iCvars[ 4 ] ) ); // random time between 2 cvar floats
	set_task( fTimeAirDrop, "OnCreateAirDrop", TASK_AIRDROP, _, _, "b" );
	
	return PLUGIN_CONTINUE;
}

public DropAfkPlayers( )
{
	engfunc( EngFunc_RemoveEntity, g_iAirPlaneEnt ); // remove airplane
	
	new szPlayers[ 32 ], iNum, iTempID;
	get_players( szPlayers, iNum, "ah" );

	for( new i; i < iNum; i++ )
	{
		iTempID = szPlayers[ i ];

		if( g_bPlayerInPlane[ iTempID ] )
		{
			ExecuteHamB( Ham_Player_Jump, iTempID ); // make them jump
			client_print( iTempID, print_center, "%L", iTempID, "EMERGENCY_DROP" );
			
			ExecuteForward( g_iFwUrgentJumpPlane, g_iDummyResult, iTempID );
		}
	}
}

@SetModel( iEnt, const szModel[ ] ) // set weapons glow
{
	if( ! pev_valid( iEnt ) )
	return FMRES_IGNORED;

	new szClassName[ 32 ];
	pev( iEnt, pev_classname, szClassName, charsmax( szClassName ) );
	
	if( ! equal( szClassName, "weaponbox" ) )
	return FMRES_IGNORED;
	
	new iWeaponEntity = GetWeaponBoxWeaponType( iEnt ); // get weapon entity
	
	new iRarity = pev( iWeaponEntity, pev_iuser2 );
	
	if( iRarity )
	GlowWeapon( iEnt, iRarity ); // set glow
	
	return FMRES_IGNORED;
}

public OnMessageStatusIcon( iMsgId, iMsgDest, id )
{
	static szIcon[ 8 ];
	get_msg_arg_string( 2, szIcon, charsmax( szIcon ) );

	if( equal( szIcon, "buyzone" ) && get_msg_arg_int( 1 ) ) // block buyzone, not needed in this mod
	{
		set_pdata_int( id, 235, get_pdata_int( id, 235 ) & ~ ( 1 << 0 ) );
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

@CmdStart( id, iHandle ) // when opening airdrop, you have to press IN_USE
{
	if( ! is_user_alive( id ) )
	return FMRES_IGNORED;

	static iButtons;
	iButtons = get_uc( iHandle, UC_Buttons );
	
	if( iButtons & IN_USE )
	{
		new Float:fOriginPlayer[ 3 ], Float:fOriginEnt[ 3 ], iEnt = -1;
		pev( id, pev_origin, fOriginPlayer );
		
		while( ( iEnt = find_ent_by_class( iEnt, g_iConfig[ AIRDROP_CLASSNAME ] ) ) )
		{
			pev( iEnt, pev_origin, fOriginEnt );
			
			if( ( get_distance_f( fOriginPlayer, fOriginEnt ) <= get_pcvar_float( g_iCvars[ 7 ] ) ) && ( pev( iEnt, pev_flags ) & FL_ONGROUND ) ) // check if distance between player and airdrop is lower than cvar and airdrop has landed
			{
				OpenAirDrop( id, iEnt ); // open the airdrop
			}
		}
	}
	return FMRES_IGNORED;
}

@HamTakeDamage_Pre( iVictim, iInflicter, iAttacker, Float:fDamage ) // give extra damage to each glow
{
	if( ! is_user_connected( iAttacker ) )
	return HAM_IGNORED;
	
	new iEnt = get_pdata_cbase( iAttacker, m_pActiveItem );
	
	if( ! pev_valid( iEnt ) )
	return HAM_IGNORED;
	
	new iWeaponId = cs_get_weapon_id( iEnt );
	
	if( iWeaponId <= 0 )
	return HAM_IGNORED;
	
	if( iWeaponId == CSW_FLASHBANG || iWeaponId == CSW_SMOKEGRENADE )
	return HAM_IGNORED;
	
	new iGlow = pev( iEnt, pev_iuser2 );
	
	if( ! iGlow )
	return HAM_IGNORED;
	
	new iExtraDamage = GetExtraDamage( iGlow );
	
	SetHamParamFloat( 4, fDamage + iExtraDamage );
	return HAM_IGNORED;
}

@AirDropThink( iEnt )
{
	if( pev_valid( iEnt ) != 2 )
	return PLUGIN_CONTINUE;
	
	new Float:fVelocity[ 3 ];
	pev( iEnt, pev_velocity, fVelocity );
	
	set_pev( iEnt, pev_nextthink, get_gametime( ) + 0.01 );
	
	if( ( pev( iEnt, pev_flags ) & FL_ONGROUND ) || ( pev( iEnt, pev_flags ) & FL_INWATER ) ) // has landed on ground / in water
	{
		if( ! pev( iEnt, pev_iuser2 ) )
		{
			engfunc( EngFunc_SetModel, iEnt, g_iDataAirDrop[ AirDrop_Model_Ground ] ); 
			engfunc( EngFunc_SetSize, iEnt, Float:{ -35.0, -40.0, -65.0 }, Float:{ 35.0, 40.0, 65.0 } );
			
			set_pev( iEnt, pev_solid, SOLID_BBOX );
			set_pev( iEnt, pev_movetype, MOVETYPE_TOSS );
			
			client_cmd( 0, "spk sound/%s", g_iSounds[ AirDrop_Land_Sound ] );
			
			set_pev( iEnt, pev_iuser2, 1 );
		}
	}
	
	else if( fVelocity[ 2 ] < 0.0 ) // still in air
	{
		fVelocity[ 2 ] = g_fCachedAirDropVelocity;
		set_pev( iEnt, pev_velocity, fVelocity );	
	}
	return PLUGIN_CONTINUE;
}

public OnCreateAirDrop( )
{
	if( g_iAirDrops <= get_pcvar_num( g_iCvars[ 5 ] ) ) // create as many AirDrops as described in the cvar
	{
		MakeAirDropEnt( );
		g_iAirDrops++;
	}
	
	else
	{
		remove_task( TASK_AIRDROP ); // remove airdrop task, no more airdrops needed
	}
}

public client_PreThink( id )
{
	if( ! is_user_alive( id ) )
	return PLUGIN_CONTINUE;
	
	if( g_bIsPlayerInParachute[ id ] )
	{
		new Float:fVelocity[ 3 ]; 
		pev( id, pev_velocity, fVelocity ); 
		
		if( ! g_bLandedPlayer[ id ] && ( ( pev( id, pev_flags ) & FL_ONGROUND ) || ( pev( id, pev_flags ) & FL_INWATER ) ) ) // player has landed on ground/ in water
		{
			g_bIsPlayerInParachute[ id ] = false; // not in parachute anymore
			set_pev( id, pev_sequence, detach );
			
			set_pev( id, pev_solid, SOLID_SLIDEBOX );
			set_pev( id, pev_movetype, MOVETYPE_WALK );
			
			ReLocatePlayer( id );
			
			set_user_rendering( id );
			
			client_cmd( id, "spk sound/%s", g_iSounds[ Landing_Sound ] ); // emit landing sound
			
			g_bLandedPlayer[ id ] = true;
		}
		
		else if( fVelocity[ 2 ] < 0.0 ) // still in air
		{
			fVelocity[ 2 ] = g_fCachedParachuteVelocity;
			set_pev( id, pev_velocity, fVelocity );
		} 
	}
	return PLUGIN_CONTINUE;
}

@HamPlayerImpulseCommands_Pre( id ) // block spray and replace it with camera
{
	if( ! is_user_alive( id ) )
	return HAM_IGNORED;
	
	if( ! get_pcvar_num( g_iCvars[ 2 ] ) )
	return HAM_IGNORED;
	
	if( pev( id, pev_impulse ) == 201 )
	{
		g_iPlayerView[ id ] = g_iPlayerView[ id ] == VIEW_3RDPERSON ? VIEW_NONE : VIEW_3RDPERSON;
		set_view( id, g_iPlayerView[ id ] );
		
		set_pev( id, pev_impulse, 0 );
	}
	return HAM_IGNORED;
}

public client_connect( id ) // reset vars
{	
	ResetVars( id );
}

#if defined USE_CUSTOM_SPAWN_POINTS
ReadSpawnPoints( )
{
	if( ! g_iConfig[ GAME_CUSTOM_SPAWN_POINTS_FILE ][ 0 ] )
	{
		log_amx( "[CSBR] Custom Spawn Points File Not Found" );
		return PLUGIN_HANDLED;
	}

	new szFilename[ 256 ], szData[ 64 ], szX_Axi[ 21 ], szY_Axi[ 21 ], szZ_Axi[ 21 ], eData[ SpawnPointsData ];		
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ GAME_CUSTOM_SPAWN_POINTS_FILE ] );

	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{			
			trim( szData );
			remove_quotes( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/':
				{
					continue;
				}
				
			default:
				{
					if( parse( szData, szX_Axi, charsmax( szX_Axi ), szY_Axi, charsmax( szY_Axi ), szZ_Axi, charsmax( szZ_Axi ) ) < 3 )
					continue;
					
					eData[ SP_Axis ][ 0 ] = _:str_to_float( szX_Axi );
					eData[ SP_Axis ][ 1 ] = _:str_to_float( szY_Axi );
					eData[ SP_Axis ][ 2 ] = _:str_to_float( szZ_Axi );

					ArrayPushArray( g_aCustomSpawnPoints, eData );
				}
			}
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}

WriteToFile( const szString[ ] )
{
	new szFilename[ 256 ];	
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ GAME_CUSTOM_SPAWN_POINTS_FILE ] );
	
	new iFile = fopen( szFilename, "at" );
	
	if( ! iFile )
	return -1;
	
	new szLine[ 32 ];
	formatex( szLine, charsmax( szLine ), "^n%s", szString );
	
	fputs( iFile, szLine );
	
	fclose( iFile );
	return 1;
}
#endif

WritePlaneDirectionToFile( const szString[ ] )
{
	new szFilename[ 256 ];	
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ PLANE_ORIGINS_FILE ] );
	
	new iFile = fopen( szFilename, "at" );
	
	if( ! iFile )
	return -1;
	
	new szLine[ 128 ];
	formatex( szLine, charsmax( szLine ), "^n%s", szString );
	
	fputs( iFile, szLine );
	
	fclose( iFile );
	return 1;
}

ReadWeapons( ) // read our weapons from .ini
{
	if( ! g_iConfig[ GAME_WEAPONS_FILE ][ 0 ] )
	{
		log_amx( "[CSBR] Weapons File Not Found" );
		return PLUGIN_HANDLED;
	}

	new szFilename[ 256 ], eData[ WeaponData ], szWeaponName[ 32 ], szRarity[ 18 ], szData[ 128 ];	
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_MANAGMENT, g_iConfig[ GAME_WEAPONS_FILE ] );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{		
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{
			trim( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/':
				{
					continue;
				}
				
			default:
				{
					if( parse( szData, szWeaponName, charsmax( szWeaponName ), szRarity, charsmax( szRarity ) ) < 2 )
					continue;
					
					for( new i; i < sizeof g_szForbiddenWeapons; i++ )
					{
						if( equal( szWeaponName, g_szForbiddenWeapons[ i ] ) )
						{
							continue;
						}
					}
					
					new iRarity;
					if( TrieGetCell( g_tRarityTrie, szRarity, iRarity ) )
					{
						if( ! ( RARITY_GREY <= iRarity <= RARITY_GOLD ) )
						{
							continue;
						}
					}	
					
					eData[ Weapon_Rarity ] = iRarity;					
					eData[ Weapon_Name ] = szWeaponName;
					
					ArrayPushArray( g_aWeaponData, eData );		
				}
			}
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}

ReadPlaneOrigins( )
{
	if( ! g_iConfig[ PLANE_ORIGINS_FILE ][ 0 ] )
	{
		log_amx( "[CSBR] Plane Origins File Not Found" );
		return PLUGIN_HANDLED;
	}

	new
	szFilename[ 256 ], szData[ 128 ], szOrigin1[ 10 ], szOrigin2[ 10 ], szOrigin3[ 10 ] ,
	szAngle1[ 10 ], szAngle2[ 10 ], szAngle3[ 10 ], szVelocity1[ 10 ], szVelocity2[ 10 ], szVelocity3[ 10 ], eData[ PlaneData ];
	
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ PLANE_ORIGINS_FILE ] );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{		
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{
			trim( szData );
			remove_quotes( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/':
				{
					continue;
				}
				
			default:
				{
					if( parse( szData, szOrigin1, charsmax( szOrigin1 ), szOrigin2, charsmax( szOrigin2 ), szOrigin3, charsmax( szOrigin3 ), szAngle1, charsmax( szAngle1 ), szAngle2, charsmax( szAngle2 ), szAngle3, charsmax( szAngle3 ), szVelocity1, charsmax( szVelocity1 ), szVelocity2, charsmax( szVelocity2 ), szVelocity3, charsmax( szVelocity3 ) ) < 9 )
					{
						continue;
					}
					
					eData[ PlaneOrigin ][ 0 ] = _:str_to_float( szOrigin1 );
					eData[ PlaneOrigin ][ 1 ] = _:str_to_float( szOrigin2 );
					eData[ PlaneOrigin ][ 2 ] = _:str_to_float( szOrigin3 );
					
					eData[ PlaneAngle ][ 0 ] = _:str_to_float( szAngle1 );
					eData[ PlaneAngle ][ 1 ] = _:str_to_float( szAngle2 );
					eData[ PlaneAngle ][ 2 ] = _:str_to_float( szAngle3 );
					
					eData[ PlaneVelocity ][ 0 ] = _:str_to_float( szVelocity1 );
					eData[ PlaneVelocity ][ 1 ] = _:str_to_float( szVelocity2 );
					eData[ PlaneVelocity ][ 2 ] = _:str_to_float( szVelocity3 );
					
					ArrayPushArray( g_aPlaneDirections, eData );
				}
			}
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}

ReadModels( ) // read our models from .ini
{
	if( ! g_iConfig[ GAME_MODELS_FILE ][ 0 ] )
	{
		log_amx( "[CSBR] Models File Not Found" );
		return PLUGIN_HANDLED;
	}

	new szFilename[ 256 ];	
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_MANAGMENT, g_iConfig[ GAME_MODELS_FILE ] );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{
		new szData[ 128 ], szValue[ 64 ], szKey[ 32 ];
		
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{
			trim( szData );
			remove_quotes( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/': 
				continue;
				
			default:
				{
					strtok( szData, szKey, charsmax( szKey ), szValue, charsmax( szValue ), '=' );
					trim( szKey ); 
					trim( szValue );
					
					remove_quotes( szKey );
					remove_quotes( szValue );
					
					if( ! szValue[ 0 ] )
					continue;
					
					if( equal( szKey, "AIRDROP_MODEL_FLYING" ) )
					{
						g_iDataAirDrop[ AirDrop_Model_Flying ] = szValue;
						precache_model( szValue );
					}
					
					else if( equal( szKey, "AIRDROP_MODEL_GROUND" ) )
					{
						g_iDataAirDrop[ AirDrop_Model_Ground ] = szValue;
						precache_model( szValue );
					}
					
					else if( equal( szKey, "AIRPLANE_MODEL" ) )
					{
						g_iDataAirPlane[ AirPlane_Model ] = szValue;
						precache_model( szValue );
					}
				}
			}
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}

#if defined USE_AUTOMATIC_SPAWN_POINTS
ReadMinimumPoint( )
{
	if( ! g_iConfig[ AUTO_POINTS_FILE ][ 0 ] )
	{
		log_amx( "[CSBR] Auto Points File Not Found" );
		return PLUGIN_HANDLED;
	}

	new szFilename[ 256 ], szData[ 10 ];
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_iConfig[ AUTO_POINTS_FILE ] );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{			
			trim( szData );
			remove_quotes( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/': 
				continue;
				
			default:
				{
					g_fMinimumSpawnPoint = str_to_float( szData );
				}
			}
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}
#endif

ReadConfig( )
{
	new szFilename[ 256 ];
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_MANAGMENT, CSBR_Config_File );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{
		new szData[ 128 ], szValue[ 64 ], szKey[ 64 ];
		
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{
			trim( szData );
			remove_quotes( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/': 
				continue;
				
			default:
				{						
					strtok( szData, szKey, charsmax( szKey ), szValue, charsmax( szValue ), '=' );
					
					trim( szKey ); 
					trim( szValue );
					
					remove_quotes( szKey );
					remove_quotes( szValue );
					
					if( ! szValue[ 0 ] )
					continue;
					
					if( equal( szKey, "AIRDROP_CLASSNAME" ) )
					{
						g_iConfig[ AIRDROP_CLASSNAME ] = szValue;
					}
					
					else if( equal( szKey, "AIRPLANE_CLASSNAME" ) )
					{
						g_iConfig[ AIRPLANE_CLASSNAME ] = szValue;
					}
					
					else if( equal( szKey, "GAME_SOUNDS_FILE" ) )
					{
						g_iConfig[ GAME_SOUNDS_FILE ] = szValue;
					}
					
					else if( equal( szKey, "GAME_MODELS_FILE" ) )
					{
						g_iConfig[ GAME_MODELS_FILE ] = szValue;
					}
					
					else if( equal( szKey, "PLANE_ORIGINS_FILE" ) )
					{
						g_iConfig[ PLANE_ORIGINS_FILE ] = szValue;
					}
					
					else if( equal( szKey, "GAME_WEAPONS_FILE" ) )
					{
						g_iConfig[ GAME_WEAPONS_FILE ] = szValue;
					}
					
					else if( equal( szKey, "GAME_CUSTOM_SPAWN_POINTS_FILE" ) )
					{
						g_iConfig[ GAME_CUSTOM_SPAWN_POINTS_FILE ] = szValue;
					}
					
					else if( equal( szKey, "ARROW_ICON_SPRITE" ) )
					{
						g_iConfig[ ARROW_ICON_SPRITE ] = szValue;
					}
					
					else if( equal( szKey, "AUTO_POINTS_FILE" ) )
					{
						g_iConfig[ AUTO_POINTS_FILE ] = szValue;
					}
					
					else if( equal( szKey, "ZONE_ORIGINS_FILE" ) )
					{
						g_iConfig[ ZONE_ORIGINS_FILE ] = szValue;
					}
					
					else if( equal( szKey, "POSSIBLE_WEAPONS_AIRDROP" ) )
					{
						while( szValue[ 0 ] != 0 && strtok( szValue, szKey, charsmax( szKey ), szValue, charsmax( szValue ), ',', 1 ) )
						{
							trim( szValue );
							remove_quotes( szKey );
							
							new iWeapon;
							if( TrieGetCell( g_tWeaponIds, szKey, iWeapon ) )
							{
								ArrayPushCell( g_aAirDropWeapons, iWeapon );
							}
						}
					}
				}
			}
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}

ReadSounds( ) // read our sounds from .ini
{
	if( ! g_iConfig[ GAME_SOUNDS_FILE ][ 0 ] )
	{
		log_amx( "[CSBR] Custom Spawn Points File Not Found" );
		return PLUGIN_HANDLED;
	}

	new szFilename[ 256 ];
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_MANAGMENT, g_iConfig[ GAME_SOUNDS_FILE ] );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{
		new szData[ 128 ], szValue[ 64 ], szKey[ 32 ];
		
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{
			trim( szData );
			remove_quotes( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/': 
				continue;
				
			default:
				{
					strtok( szData, szKey, charsmax( szKey ), szValue, charsmax( szValue ), '=' );
					trim( szKey ); 
					trim( szValue );
					
					if( ! szValue[ 0 ] )
					continue;
					
					if( equal( szKey, "PARACHUTE_DEPLOY_SOUND" ) )
					{
						g_iSounds[ Parachute_Deploy_Sound ] = szValue;
						precache_sound( szValue );
					}
					
					else if( equal( szKey, "LANDING_SOUND" ) )
					{
						g_iSounds[ Landing_Sound ] = szValue;
						precache_sound( szValue );
					}
					
					else if( equal( szKey, "AIRDROP_APPEAR_SOUND" ) )
					{
						g_iSounds[ AirDrop_Appear_Sound ] = szValue;
						precache_sound( szValue );
					}
					
					else if( equal( szKey, "AIRDROP_LAND_SOUND" ) )
					{
						g_iSounds[ AirDrop_Land_Sound ] = szValue;
						precache_sound( szValue );
					}
				}
			}
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}

MakeAirPlane( )
{
	new Float:fOrigin[ 3 ], Float:fPlayerOrigin[ 3 ], Float:fAngle[ 3 ] , Float:fVelocity[ 3 ];
	GetRandomPlaneDirection( fOrigin, fAngle, fVelocity );

	if( fOrigin[ 2 ] > 3000.0 )
	{
		fOrigin[ 2 ] = 3000.0;
	}
	
	g_iAirPlaneEnt = create_entity( "info_target" );
	
	set_pev( g_iAirPlaneEnt, pev_classname, g_iConfig[ AIRPLANE_CLASSNAME ] );
	set_pev( g_iAirPlaneEnt, pev_solid, SOLID_NOT ); // we dont want it to collide with players who jump
	set_pev( g_iAirPlaneEnt, pev_movetype, MOVETYPE_FLY ); // its gonna fly, so..
	engfunc( EngFunc_SetModel, g_iAirPlaneEnt, g_iDataAirPlane[ AirPlane_Model ] );
	engfunc( EngFunc_SetOrigin, g_iAirPlaneEnt, fOrigin );
	set_pev( g_iAirPlaneEnt, pev_angles, fAngle ); // set correct angles, we don't want a plane going backwards
	set_pev( g_iAirPlaneEnt, pev_velocity, fVelocity );
	
	fPlayerOrigin[ 0 ] = fOrigin[ 0 ];
	fPlayerOrigin[ 1 ] = fOrigin[ 1 ];
	fPlayerOrigin[ 2 ] = fOrigin[ 2 ] - 5.0; // reduce the Z axi a little bit, find the best place for players to stand
	
	new szPlayers[ 32 ], iNum, iTempID;
	get_players( szPlayers, iNum, "ah" );
	
	for( new i = 0; i < iNum; i++ )
	{
		iTempID = szPlayers[ i ];
		
		AttachPlayerToPlane( iTempID, fOrigin, fAngle, fVelocity ); // attach the players to the plane
	}
}

AttachPlayerToPlane( id, Float:fOrigin[ 3 ], Float:fAngle[ 3 ], Float:fVelocity[ 3 ] )
{
	client_cmd( id, "spk sound/misc/plane_drone.wav" );
	
	set_task( 0.1, "OnShowJumpHUD", id + TASK_SHOW_MSG_AIRPLANE, .flags="b" );
	
	set_pev( id, pev_solid, SOLID_NOT ); // make him SOLID_NOT so he doesnt collide with the others
	ReLocatePlayer( id );
	
	set_user_rendering( id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 0 ); // make player invisibile
	
	fAngle[ 0 ] += 100.0;
	
	engfunc( EngFunc_SetOrigin, id, fOrigin );
	set_pev( id, pev_angles, fAngle );
	set_pev( id, pev_fixangle, 1 ); // idk if its really needed
	set_pev( id, pev_velocity, fVelocity );
	set_pev( id, pev_gravity, 0.00001 ); // 0.0 doesnt work so lets set an extra small value
	set_pev( id, pev_maxspeed, 0.00001 ); // same as above
	
	g_bIsPlayerInParachute[ id ] = false; // player isnt in parachute
	g_bPlayerInPlane[ id ] = true; // but hes in airplane
	
	fOrigin[ 2 ] += 1000.0;
	
	new iCameraEnt = create_entity( "info_target" );
	
	set_pev( iCameraEnt, pev_classname, "camera_ent" );
	set_pev( iCameraEnt, pev_solid, SOLID_NOT );
	set_pev( iCameraEnt, pev_movetype, MOVETYPE_FLY );
	engfunc( EngFunc_SetModel, iCameraEnt, "models/rpgrocket.mdl" );
	engfunc( EngFunc_SetOrigin, iCameraEnt, fOrigin );
	set_pev( iCameraEnt, pev_angles, fAngle );
	set_pev( iCameraEnt, pev_velocity, fVelocity );
	
	set_rendering( iCameraEnt, kRenderFxNone, 0, 0, 0, kRenderTransAlpha, 0 );
	
	attach_view( id, iCameraEnt );
}

public OnShowJumpHUD( id )
{
	id -= TASK_SHOW_MSG_AIRPLANE;
	
	set_dhudmessage( 255, 0, 255, 0.50, 0.40, 2, 0.0, 0.2, 0.1, 1.5, false );
	show_dhudmessage( id, "Press SPACE to Jump" );
}

GetRandomPlaneDirection( Float:fOrigin[ 3 ] , Float:fAngle[ 3 ], Float:fVelocity[ 3 ] )
{
	new iRandom = random_num( 0, ArraySize( g_aPlaneDirections ) - 1 );
	
	new eData[ PlaneData ];
	
	ArrayGetArray( g_aPlaneDirections, iRandom, eData );
	
	for( new i; i < 3; i++ )
	{
		fOrigin[ i ]   = eData[ PlaneOrigin ][ i ];
		fAngle[ i ]    = eData[ PlaneAngle ][ i ];
		fVelocity[ i ] = eData[ PlaneVelocity ][ i ];
	}
	
	return 1;
}

ReLocatePlayer( id ) // bugfix
{
	new Float:fOrigin[ 3 ];
	pev( id, pev_origin, fOrigin );

	engfunc( EngFunc_SetOrigin, id, fOrigin );
}

MakeAirDropEnt( )
{
	new iEnt = engfunc( EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target" ) );

	new Float:fOrigin[ 3 ];
	
	#if defined USE_AUTOMATIC_SPAWN_POINTS
	ROGGetOrigin( fOrigin ); // get a valid origin
	#else
	if( GetRandomOrigin( fOrigin ) == -1 ) // no origins found
	{
		log_amx( "[CSBR] No Custom Origins Found" );
		return PLUGIN_HANDLED;
	}
	#endif

	fOrigin[ 2 ] = 4000.0; // max height
	engfunc( EngFunc_SetOrigin, iEnt, fOrigin );
	
	set_pev( iEnt, pev_classname, g_iConfig[ AIRDROP_CLASSNAME ] );
	
	set_pev( iEnt, pev_movetype, MOVETYPE_TOSS ); // if it lands on the moving boat, to follow the boat instead of levitating
	set_pev( iEnt, pev_solid, SOLID_BBOX );
	
	engfunc( EngFunc_SetModel, iEnt, g_iDataAirDrop[ AirDrop_Model_Flying ] ); 
	engfunc( EngFunc_SetSize, iEnt, Float:{ -35.0, -40.0, -5.0 }, Float:{ 35.0, 40.0, 5.0 } );

	set_pev( iEnt, pev_nextthink, get_gametime( ) + 0.01 ); // make it think
	
	client_cmd( 0, "spk sound/%s", g_iSounds[ AirDrop_Appear_Sound ] ); // emit airdrop appear sound
	
	client_print( 0, print_center, "%L", LANG_PLAYER, "AIRDROP_ARRIVED" );
	return PLUGIN_CONTINUE;
}

OpenAirDrop( id, iEnt ) // player is opening airdrop
{
	new Float:fOrigin[ 3 ];
	pev( iEnt, pev_origin, fOrigin );

	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( TE_EXPLOSION ); // make effect
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 2 ] );
	write_short( g_iSpriteIndexExplosion );
	write_byte( 30 );
	write_byte( 15 );
	write_byte( TE_EXPLFLAG_NONE ); // no dmg
	message_end( );
	
	engfunc( EngFunc_RemoveEntity, iEnt ); // remove the ent
	
	new iRandomEntry = random_num( 0, ArraySize( g_aAirDropWeapons ) - 1 );
	
	new iWeapon = ArrayGetCell( g_aAirDropWeapons, iRandomEntry );
	
	new szWeaponName[ 32 ];
	get_weaponname( iWeapon, szWeaponName, charsmax( szWeaponName ) );
	
	SpawnRandomWeapon( szWeaponName, fOrigin );
	ExecuteForward( g_iFwOpenAirDrop, g_iDummyResult, id, iWeapon );
}

SpawnRandomWeapon( const szWeaponName[ ], Float:fOrigin[ 3 ] )
{
	OrpheuCreateWeaponBox( szWeaponName, RandomGlowByChance( ), fOrigin );
}

CheckDirectory( )
{
	new szDir[ 256 ], szZoneOriginsFile[ 256 ], szSpawnPointsFile[ 256 ], szPlaneDirectionsFile[ 256 ], szMinimumHeightFile[ 256 ];
	formatex( szDir, charsmax( szDir ), "%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName );

	if( ! dir_exists( szDir ) )
	{
		mkdir( szDir );

		formatex( szZoneOriginsFile, charsmax( szZoneOriginsFile ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ ZONE_ORIGINS_FILE ] );
		formatex( szSpawnPointsFile, charsmax( szSpawnPointsFile ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ GAME_CUSTOM_SPAWN_POINTS_FILE ] );
		formatex( szPlaneDirectionsFile, charsmax( szPlaneDirectionsFile ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ PLANE_ORIGINS_FILE ] );
		formatex( szMinimumHeightFile, charsmax( szMinimumHeightFile ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ AUTO_POINTS_FILE ] );
		
		if( ! file_exists( szZoneOriginsFile ) )
		{
			fopen( szZoneOriginsFile, "w" );
		}

		if( ! file_exists( szSpawnPointsFile ) )
		{
			fopen( szSpawnPointsFile, "w" );
		}

		if( ! file_exists( szPlaneDirectionsFile ) )
		{
			fopen( szPlaneDirectionsFile, "w" );
		}

		if( ! file_exists( szMinimumHeightFile ) )
		{
			fopen( szMinimumHeightFile, "w" );
		}
	}
	return 1;
}

RandomGlowByChance( ) // stock to pick a glow by chances
{
	new iReturnValue;
	
	const iPercentage = 100;
	new iRandomNum = random_num( 0, iPercentage );

	switch( iRandomNum )
	{

	case 0 .. 40:
		iReturnValue = RARITY_BLUE;

	case 41 .. 75:
		iReturnValue = RARITY_PURPLE;

	case 76 .. 100:
		iReturnValue = RARITY_GOLD;
	}
	return iReturnValue
}

GlowWeapon( iEnt, iColor ) // glow the weapon
{
	switch( iColor )
	{
	case RARITY_GREY:
		set_rendering( iEnt, kRenderFxGlowShell, 192, 192, 192, kRenderNormal, 50 );

	case RARITY_GREEN:
		set_rendering( iEnt, kRenderFxGlowShell, 0, 255, 0, kRenderNormal, 50 );	
		
	case RARITY_BLUE:
		set_rendering( iEnt, kRenderFxGlowShell, 0, 181, 255, kRenderNormal, 50 );

	case RARITY_PURPLE:
		set_rendering( iEnt, kRenderFxGlowShell, 128, 0, 128, kRenderNormal, 50 );

	case RARITY_GOLD:
		set_rendering( iEnt, kRenderFxGlowShell, 255, 215, 0, kRenderNormal, 50 );
	}
}

GetExtraDamage( iGlowColor ) // get damage according to glow
{
	return iGlowColor * get_pcvar_num( g_iCvars[ 9 ] );
}

RemoveAllWeaponBox( )
{
	new iEnt = -1;
	while( ( iEnt = find_ent_by_class( iEnt, "weaponbox" ) ) != 0 )
	{
		set_pdata_int( iEnt, m_pfnThink, CWeaponBoxKill_Address, 0 );
	}
}

GetWeaponBoxWeaponType( iEnt )
{
	new iWeapon;
	for( new i = 1; i <= 5; i++ )
	{
		iWeapon = get_pdata_cbase( iEnt, m_rgpPlayerItems_CWeaponBox[ i ], XO_CWEAPONBOX );
		if( iWeapon > 0 ) 
		{
			return iWeapon;
		}
	}
	return 0;
}

#if defined USE_CUSTOM_SPAWN_POINTS
GetRandomOrigin( Float:fOrigin[ 3 ] )
{
	new eData[ SpawnPointsData ];
	
	new iArraySize = ArraySize( g_aCustomSpawnPoints );
	
	if( ! iArraySize )
	return -1;
	
	new iRandomEntry = random_num( 0, iArraySize - 1 );
	
	ArrayGetArray( g_aCustomSpawnPoints, iRandomEntry, eData );
	
	for( new i; i < 3; i++ )
	{
		fOrigin[ i ] = eData[ SP_Axis ][ i ];
	}
	return 1;
}
#endif

OrpheuCreateWeaponBox( const szName[ ], const iRarity, const Float:fOrigin[ 3 ] )
{
	new WeaponEntity;

	new WeaponBoxEntity = OrpheuCall( HandleCreateNamedEntityFunc, IntClassNameString ) ;
	if( pev_valid( WeaponBoxEntity ) != 2 )
	{
		return 0;
	}
	
	engfunc( EngFunc_SetOrigin, WeaponBoxEntity, fOrigin );
	ExecuteHam( Ham_Spawn, WeaponBoxEntity );
	
	WeaponEntity = create_entity( szName );
	
	if( pev_valid( WeaponEntity ) != 2 )
	{
		remove_entity( WeaponEntity );
	}

	ExecuteHamB( Ham_Spawn, WeaponEntity );
	new WeaponID = cs_get_weapon_id( WeaponEntity );
	
	if( WeaponID <= 0 )
	{
		remove_entity( WeaponEntity );
	}
	
	OrpheuCall( HandlePackWeaponFunc, WeaponBoxEntity, WeaponEntity );
	if( g_szWeaponBoxModels[ WeaponID ][ 0 ] != EOS ) 
	{ 
		engfunc( EngFunc_SetModel, WeaponBoxEntity, g_szWeaponBoxModels[ WeaponID ] );
	}
	
	set_pdata_int( WeaponBoxEntity, m_pfnThink, CWeaponBoxKill_Address, 0 );
	
	new iAmmoIndex = g_eAmmoIndex[ WeaponID ][ AmmoIndex ];
	new iAmmoCount = g_eAmmoIndex[ WeaponID ][ AmmoCount ];
	
	if( iAmmoIndex )
	{
		OrpheuCall( HandlePackAmmoFunc, WeaponBoxEntity, g_iAmmoNames[ iAmmoIndex ], iAmmoCount );
	}
	
	set_pev( WeaponEntity, pev_iuser2, iRarity );
	GlowWeapon( WeaponBoxEntity, iRarity );
	
	return 1;
}

ResetVars( const id )
{
	g_iPlayerView[ id ] = VIEW_NONE;
	g_bIsPlayerInParachute[ id ] = false;
	g_bPlayerInPlane[ id ] = false;
	g_bLandedPlayer[ id ] = false;
}