#include < amxmodx >
#include < amxmisc >
#include < fakemeta >
#include < hamsandwich >
#include < engine >
#include < rog >
#include < csbr_config >

#define IsValidType(%1) (ItemType_MedKit <= %1 <= ItemType_Drink)

#define set_bit(%1,%2)	(%1 |= (1<<%2))
#define get_bit(%1,%2)	(%1 & (1<<%2))
#define clr_bit(%1,%2)	(%1 &= ~(1<<%2))

#define USE_CUSTOM_SPAWN_POINTS
//#define USE_AUTOMATIC_SPAWN_POINTS

//#define DUMP_ORIGIN_DATA

enum ( += 12345 )
{
	TASK_MEDKIT,
	TASK_DRINK,
	TASK_ENDED_MEDKIT,
	TASK_ENDED_DRINK
}

enum
{
	ItemType_MedKit,
	ItemType_Drink,
	
	ItemType_ItemCount
};

enum _:Config
{
	MEDKIT_MODEL[ 32 ],
	DRINK_MODEL[ 32 ],
	GAME_CUSTOM_SPAWN_POINTS_FILE[ 32 ],
	HEALING_ENTITIES_FILE[ 32 ],
	AUTO_POINTS_FILE[ 32 ]
}

enum _:EntitiesData
{
	iEntityType,
	iEntityCount
}

enum _:SpawnPointsData
{
Float:SP_Axis[ 3 ]
}

new const g_szTypes[ ][ ] =
{
	"ItemType_MedKit",
	"ItemType_Drink"
}

new const g_iTypes[ ] =
{
	ItemType_MedKit,
	ItemType_Drink
}

new const g_szItemNames[ ItemType_ItemCount ][ ] =
{
	"item_medkit",
	"item_drink"
};

new const g_szBackPackCmd[ ][ ] =
{
	"say /backpack",
	"say_team /backpack",
	"say /bp",
	"say_team /bp"
}

new g_iPlayerItems[ MAX_PLAYERS + 1 ][ ItemType_ItemCount ];
new g_iConfig[ Config ];
new g_iCvars[ 5 ];

new Float:g_fMinimumPoint;

new const g_szItemClass[ ] = "item_heal";

new g_iMaxPlayers;
new g_iMsgBarTime;
new g_iMedKit;
new g_iDrink;
new g_iFwOpenBackpack;
new g_iFwPlayerUseHeal;
new g_iFwPlayerPickUpHeal;
new g_iDummyResult;

new g_szMapName[ 32 ];
new g_szConfigsDir[ 32 ];

new Trie:g_tType;

new Array:g_aEntities;

#if defined USE_CUSTOM_SPAWN_POINTS
new Array:g_aCustomSpawnPoints;
#endif

public plugin_init( )
{
	register_plugin( "CS Battle Royale BackPack", VERSION, "DoNii" );
	
	register_dictionary( "cs_battleroyale.txt" );
	
	#if defined USE_AUTOMATIC_SPAWN_POINTS
	ROGInitialize( get_cvar_float( "csbr_distance_between_points" ), "CheckOrigin" );
	
	#if defined DUMP_ORIGIN_DATA
	ROGDumpOriginData( );
	#endif
	#endif
	
	g_iMsgBarTime = get_user_msgid( "BarTime" );
	
	g_iCvars[ 0 ] = register_cvar( "csbr_medkit_consume_time", "10" );
	g_iCvars[ 1 ] = register_cvar( "csbr_drink_consume_time", "3" );
	g_iCvars[ 2 ] = register_cvar( "csbr_medkit_heal", "100" );
	g_iCvars[ 3 ] = register_cvar( "csbr_drink_heal", "25" );
	g_iCvars[ 4 ] = register_cvar( "csbr_max_items_carry", "3" );
	
	register_logevent( "OnRoundStart", 2, "1=Round_Start" );
	
	for( new i; i < sizeof g_szBackPackCmd; i++ )
	{
		register_clcmd( g_szBackPackCmd[ i ], "@BackPack");
	}
	
	register_touch( "player", g_szItemClass, "@Touch" );
	
	RegisterHam( Ham_Spawn, "player", "@HamSpawn_Post", 1 );
	
	register_forward( FM_CmdStart, "@CmdStart" );
	
	g_iMaxPlayers = get_maxplayers( );
	
	g_iFwOpenBackpack      =   CreateMultiForward( "PlayerOpenBackpack", ET_IGNORE, FP_CELL          );
	g_iFwPlayerUseHeal     =   CreateMultiForward( "PlayerUseHeal",      ET_IGNORE, FP_CELL, FP_CELL );
	g_iFwPlayerPickUpHeal  =   CreateMultiForward( "PlayerPickUpHeal",   ET_IGNORE, FP_CELL, FP_CELL );
}

public plugin_precache( )
{
	g_tType = TrieCreate( );
	g_aEntities = ArrayCreate( EntitiesData );
	
	get_configsdir( g_szConfigsDir, charsmax( g_szConfigsDir ) );
	get_mapname( g_szMapName, charsmax( g_szMapName ) );
	
	ReadConfig( );
	
	#if defined USE_CUSTOM_SPAWN_POINTS
	g_aCustomSpawnPoints = ArrayCreate( SpawnPointsData );
	ReadSpawnPoints( );
	#endif
	
	#if defined USE_AUTOMATIC_SPAWN_POINTS
	ReadMinimumPoint( );
	#endif
	
	for( new i; i < sizeof g_szTypes; i++ )
	{
		TrieSetCell( g_tType, g_szTypes[ i ], g_iTypes[ i ] );
	}
	
	precache_model( g_iConfig[ MEDKIT_MODEL ] );
	precache_model( g_iConfig[ DRINK_MODEL ] );
	
	ReadEntities( );
}

public RoundEnded( )
{
	remove_entity_name( g_szItemClass );
}

public OnRoundStart( )
{
	remove_entity_name( g_szItemClass );
}

public CheckOrigin( Float:fOrigin[ 3 ] )
{
	if( fOrigin[ 2 ] < g_fMinimumPoint )
	{
		return 0;
	}
	return 1;
}

public client_connect( id )
{
	ClearBackPack( id );
	ClearBits( id );
}

public @HamSpawn_Post( id )
{
	ClearBackPack( id );
}

public RoundStarted( )
{
	#if defined USE_AUTOMATIC_SPAWN_POINTS
	ROGShuffleOrigins( );
	#endif

	new eData[ EntitiesData ];
	
	for( new i; i < ArraySize( g_aEntities ); i++ )
	{
		ArrayGetArray( g_aEntities, i, eData );
		
		CreateCustomEntity( eData[ iEntityType ], eData[ iEntityCount ] );
	}
}

@CmdStart( id, iHandle )
{
	if( ! is_user_alive( id ) )
	return FMRES_IGNORED;

	if( ! get_bit( g_iMedKit, id ) && ! get_bit( g_iDrink, id ) )
	return FMRES_IGNORED;
	
	new iButton = entity_get_int( id, EV_INT_button );
	
	if( iButton & IN_USE )
	{
		entity_set_int( id, EV_INT_button, entity_get_int( id, EV_INT_button ) & ~IN_USE );
		
		new iTimeMedKit = get_pcvar_num( g_iCvars[ 0 ] );
		new iTimeDrink = get_pcvar_num( g_iCvars[ 1 ] );
		
		if( get_bit( g_iMedKit, id ) )
		{						
			UTIL_BarTime( id, iTimeMedKit );
			set_task( float( iTimeMedKit ), "OnEndTakeMedKit", id + TASK_ENDED_MEDKIT );
			set_task( 1.0, "OnConsumingMedKit", id + TASK_MEDKIT, .flags="b" );
		}
		
		else if( get_bit( g_iDrink, id ) )
		{
			UTIL_BarTime( id, iTimeDrink );
			set_task( float( iTimeDrink ), "OnEndTakeDrink", id + TASK_ENDED_DRINK );
			set_task( 1.0, "OnConsumingDrink", id + TASK_DRINK, .flags="b" );
		}
	}
	return FMRES_IGNORED;
}

public OnConsumingMedKit( id )
{
	id -= TASK_MEDKIT;

	new Float:fVelocity[ 3 ];
	pev( id, pev_velocity, fVelocity );
	
	if( fVelocity[ 0 ] != 0.0 || fVelocity[ 1 ] != 0.0 || fVelocity[ 2 ] != 0.0 )
	{
		UTIL_BarTime( id, 0 );
		clr_bit( g_iMedKit, id );
		
		remove_task( id + TASK_ENDED_MEDKIT );
		remove_task( id + TASK_MEDKIT );
	}
	return PLUGIN_CONTINUE;
}

public OnEndTakeMedKit( id )
{
	id -= TASK_ENDED_MEDKIT;

	if( get_bit( g_iMedKit, id ) )
	{
		set_pev( id, pev_health, get_pcvar_float( g_iCvars[ 2 ] ) );
		client_print( id, print_chat, "%L", id, "TAKE_ITEM_MEDKIT", floatround( get_pcvar_float( g_iCvars[ 2 ] ) ) );
		
		g_iPlayerItems[ id ][ ItemType_MedKit ]--
		clr_bit( g_iMedKit, id );
		
		ExecuteForward( g_iFwPlayerUseHeal, g_iDummyResult, id, ItemType_MedKit );
	}
}

public OnConsumingDrink( id )
{
	id -= TASK_DRINK;

	new Float:fVelocity[ 3 ];
	pev( id, pev_velocity, fVelocity );
	
	if( fVelocity[ 0 ] != 0.0 || fVelocity[ 1 ] != 0.0 || fVelocity[ 2 ] != 0.0 )
	{
		UTIL_BarTime( id, 0 );
		clr_bit( g_iDrink, id );
		
		remove_task( id + TASK_ENDED_DRINK );
		remove_task( id + TASK_DRINK );
	}
	return PLUGIN_CONTINUE;
}

public OnEndTakeDrink( id )
{
	id -= TASK_ENDED_DRINK;

	if( get_bit( g_iDrink, id ) )
	{
		set_pev( id, pev_health, pev( id, pev_health ) + get_pcvar_float( g_iCvars[ 3 ] ) );
		client_print( id, print_chat, "%L", id, "TAKE_ITEM_DRINK", floatround( get_pcvar_float( g_iCvars[ 3 ] ) ) );
		
		g_iPlayerItems[ id ][ ItemType_Drink ]--
		clr_bit( g_iDrink, id );
		
		ExecuteForward( g_iFwPlayerUseHeal, g_iDummyResult, id, ItemType_Drink );
	}
}

@Touch( id, iItem )
{
	new iItemType = pev( iItem, pev_iuser1 );
	
	if( AddItemToPlayer( id, iItemType ) )
	{
		set_pev( iItem, pev_flags, pev( iItem, pev_flags ) | FL_KILLME ); 
		
		client_print( id, print_chat, "%L", id, "ADDED_ITEM_BACKPACK", g_szItemNames[ iItemType ] );
		ExecuteForward( g_iFwPlayerPickUpHeal, g_iDummyResult, id, iItemType );
	}
	
	return PLUGIN_CONTINUE;
}

@RemoveItems( id )
{
	new iEntId = g_iMaxPlayers;
	while( ( iEntId = engfunc( EngFunc_FindEntityByString, iEntId, "classname", g_szItemClass ) ) > 0 )
	{
		set_pev( iEntId, pev_flags, pev( iEntId, pev_flags ) | FL_KILLME );
	}
}

@BackPack( id )
{
	new iMenu = menu_create( "Your Inventory:", "@BackPack_Handler" );
	
	new szBuffer[ 64 ], szItemId[ 2 ], iItemCount;
	for( new iType; iType < sizeof g_iPlayerItems[ ]; iType++ )
	{
		iItemCount = g_iPlayerItems[ id ][ iType ];
		if( iItemCount == 0 ) continue;
		
		num_to_str( iType, szItemId, charsmax( szItemId ) );
		formatex( szBuffer, charsmax( szBuffer ), "%s \rx%d", g_szItemNames[ iType ], iItemCount );
		menu_additem( iMenu, szBuffer, szItemId );
	}
	
	menu_display( id, iMenu, 0 );
	
	ExecuteForward( g_iFwOpenBackpack, g_iDummyResult, id );
}

@BackPack_Handler( id, iMenu, iItem )
{
	new iAccess, szItemType[ 2 ], iCallback;
	menu_item_getinfo( iMenu, iItem, iAccess, szItemType, charsmax( szItemType ), _, _, iCallback );
	menu_destroy( iMenu );
	
	new iItemType = str_to_num( szItemType );
	
	if( ! IsValidType( iItemType ) )
	{
		return PLUGIN_HANDLED;
	}
	
	if( iItem < 0 || iItem > 1 ) // prevent glitch when item is MENU_EXIT
	{
		return PLUGIN_HANDLED;
	}
	
	new iPlayerHealth = pev( id, pev_health );
	
	if( iItemType == ItemType_MedKit )
	{
		if( iPlayerHealth >= MAX_HEALTH )
		{
			client_print( id, print_chat, "%L", id, "CANT_TAKE_MEDKIT", floatround( MAX_HEALTH ) );
			return PLUGIN_HANDLED;
		}
		
		else
		{
			set_bit( g_iMedKit, id );
			clr_bit( g_iDrink, id );
			
			entity_set_int( id, EV_INT_button, entity_get_int( id, EV_INT_button ) | IN_USE );
		}
	}
	
	else if( iItemType == ItemType_Drink )
	{
		if( iPlayerHealth > MAX_HEALTH - get_pcvar_float( g_iCvars[ 3 ] ) )
		{
			client_print( id, print_chat, "%L", id, "CANT_TAKE_DRINK", floatround( MAX_HEALTH - get_pcvar_float( g_iCvars[ 3 ] ) ) );
			return PLUGIN_HANDLED;
		}
		
		else
		{
			set_bit( g_iDrink, id );
			clr_bit( g_iMedKit, id );
			
			entity_set_int( id, EV_INT_button, entity_get_int( id, EV_INT_button ) | IN_USE );
		}
	}
	
	return PLUGIN_HANDLED;
}

AddItemToPlayer( id, iItemType )
{
	if( g_iPlayerItems[ id ][ iItemType ] >= get_pcvar_num( g_iCvars[ 4 ] ) )
	{
		return 0;
	}
	
	g_iPlayerItems[ id ][ iItemType ]++;
	return 1;
}

ClearBackPack( id )
{
	for( new i; i < sizeof g_iPlayerItems[ ]; i++ )
	{
		g_iPlayerItems[ id ][ i ] = 0;
	}
}

ReadEntities( )
{
	if( ! g_iConfig[ HEALING_ENTITIES_FILE ][ 0 ] )
	{
		log_amx( "[CSBR] Healing Entities File Not Found" );
		return PLUGIN_HANDLED;
	}

	new szFilename[ 256 ], szData[ 64 ], szEntityName[ 32 ], szEntityCount[ 3 ], eData[ EntitiesData ];
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_MANAGMENT, g_iConfig[ HEALING_ENTITIES_FILE ] );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{
			trim( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';':
				{
					continue;
				}
				
			default:
				{		
					
					if( parse( szData, szEntityName, charsmax( szEntityName ), szEntityCount, charsmax( szEntityCount ) ) < 2 )
					{
						continue;
					}
					
					new iType;
					if( TrieGetCell( g_tType, szEntityName, iType ) )
					{
						eData[ iEntityType ] = iType;
					}
					
					eData[ iEntityCount ] = str_to_num( szEntityCount );
					
					ArrayPushArray( g_aEntities, eData );
				}
			}
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}

ClearBits( id )
{
	clr_bit( g_iMedKit, id );
	clr_bit( g_iDrink, id );
}

ReadConfig( )
{
	new szFilename[ 256 ];
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_MANAGMENT, CSBR_Config_File );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{
		new szData[ 128 ], szValue[ 32 ], szKey[ 32 ];
		
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{
			trim( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/':
				{
					continue;
				}
				
			default:
				{
					strtok( szData, szKey, charsmax( szKey ), szValue, charsmax( szValue ), '=' );
					
					trim( szKey ); 
					trim( szValue );
					
					remove_quotes( szKey );
					remove_quotes( szValue );
					
					if( ! szValue[ 0 ] )
					{
						continue;
					}
					
					if( equal( szKey, "MEDKIT_MODEL" ) )
					{
						g_iConfig[ MEDKIT_MODEL ] = szValue;
					}

					else if( equal( szKey, "DRINK_MODEL" ) )
					{
						g_iConfig[ DRINK_MODEL ] = szValue;
					}
					
					else if( equal( szKey, "GAME_CUSTOM_SPAWN_POINTS_FILE" ) )
					{
						g_iConfig[ GAME_CUSTOM_SPAWN_POINTS_FILE ] = szValue;
					}
					
					else if( equal( szKey, "HEALING_ENTITIES_FILE" ) )
					{
						g_iConfig[ HEALING_ENTITIES_FILE ] = szValue;
					}
					
					else if( equal( szKey, "AUTO_POINTS_FILE" ) )
					{
						g_iConfig[ AUTO_POINTS_FILE ] = szValue;
					}
				}
			}
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}

CreateCustomEntity( const iType, const iCount )
{
	new Float:fOrigin[ 3 ];
	
	for( new i = 1; i <= iCount; i++ )
	{
		#if defined USE_AUTOMATIC_SPAWN_POINTS
		ROGGetOrigin( fOrigin );
		#else
		if( GetRandomOrigin( fOrigin ) == -1 ) // no origins found
		{
			log_amx( "[CSBR] No Custom Origins Found" );
			return PLUGIN_HANDLED;
		}
		#endif

		new iEntity = engfunc( EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target" ) );
		
		set_pev( iEntity, pev_classname, g_szItemClass );
		
		switch( iType )
		{
		case ItemType_MedKit: engfunc( EngFunc_SetModel, iEntity, g_iConfig[ MEDKIT_MODEL ] );
		case ItemType_Drink: engfunc( EngFunc_SetModel, iEntity, g_iConfig[ DRINK_MODEL ] );
		}

		dllfunc( DLLFunc_Spawn, iEntity );
		engfunc( EngFunc_SetSize, iEntity, Float:{ -3.0, -3.0, -3.0 }, Float:{ 3.0, 3.0, 3.0 } );
		
		engfunc( EngFunc_SetOrigin, iEntity, fOrigin );
		
		set_pev( iEntity, pev_solid, SOLID_BBOX );
		set_pev( iEntity, pev_movetype, MOVETYPE_NOCLIP );
		
		engfunc( EngFunc_DropToFloor, iEntity );
		
		set_pev( iEntity, pev_iuser1, iType );
	}
	return PLUGIN_CONTINUE;
}

#if defined USE_CUSTOM_SPAWN_POINTS
GetRandomOrigin( Float:fOrigin[ 3 ] )
{
	new eData[ SpawnPointsData ];
	
	new iArraySize = ArraySize( g_aCustomSpawnPoints );
	
	if( ! iArraySize )
	{
		return -1;
	}
	
	new iRandomEntry = random_num( 0, iArraySize - 1 );
	
	ArrayGetArray( g_aCustomSpawnPoints, iRandomEntry, eData );
	
	for( new i; i < 3; i++ )
	{
		fOrigin[ i ] = eData[ SP_Axis ][ i ];
	}
	return 1;
}

ReadSpawnPoints( )
{
	if( ! g_iConfig[ GAME_CUSTOM_SPAWN_POINTS_FILE ][ 0 ] )
	{
		log_amx( "[CSBR] Healing Entities File Not Found" );
		return PLUGIN_HANDLED;
	}

	new szFilename[ 256 ], szData[ 64 ], szX_Axi[ 21 ], szY_Axi[ 21 ], szZ_Axi[ 21 ], eData[ SpawnPointsData ];	
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ GAME_CUSTOM_SPAWN_POINTS_FILE ] );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{		
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{			
			trim( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/':
				{
					continue;
				}
				
			default:
				{
					if( parse( szData, szX_Axi, charsmax( szX_Axi ), szY_Axi, charsmax( szY_Axi ), szZ_Axi, charsmax( szZ_Axi ) ) < 3 )
					continue;

					eData[ SP_Axis ][ 0 ] = _:str_to_float( szX_Axi );
					eData[ SP_Axis ][ 1 ] = _:str_to_float( szY_Axi );
					eData[ SP_Axis ][ 2 ] = _:str_to_float( szZ_Axi );
					
					ArrayPushArray( g_aCustomSpawnPoints, eData );	
				}
			}			
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}
#endif

#if defined USE_AUTOMATIC_SPAWN_POINTS
ReadMinimumPoint( )
{
	if( ! g_iConfig[ AUTO_POINTS_FILE ][ 0 ] )
	{
		log_amx( "[CSBR] Auto Points File Not Found" );
		return PLUGIN_HANDLED;
	}

	new szFilename[ 256 ], szData[ 10 ];
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_iConfig[ AUTO_POINTS_FILE ] );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{			
			trim( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/':
				{
					continue;
				}
				
			default:
				{
					g_fMinimumPoint = str_to_float( szData );
				}
			}
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}
#endif

UTIL_BarTime( id, iTime )
{
	message_begin( MSG_ONE, g_iMsgBarTime, _, id );
	write_short( iTime );
	message_end( );
}