#include < amxmodx >
#include < amxmisc >
#include < hamsandwich >
#include < fakemeta >
#include < fun >
#include < cstrike >
#include < csbr_config >

#define SHORT_BYTES    2 
#define INT_BYTES        4 
#define BYTE_BITS        8 

enum _:Config
{
	CVARS_FILE[ 32 ]
}

new g_iConfig[ Config ];

new g_szConfigsDir[ 128 ];

new g_iPlayerPerTeam;
new g_iMaxTeams;

new g_iDummyResult;

new g_iCvars[ 2 ];

new g_iPlayersInTeam[ MAX_PLAYERS + 1 ];
new g_iPlayerTeam[ MAX_PLAYERS + 1 ];

new g_iFwAssignTeam;

new HamHook:g_iHamTakeDamageFw;
new HamHook:g_iHamTraceAttackFw;
new HamHook:g_iHamKilledFw;

const m_iNumRespawns = 365;
const m_bJustConnected = 480;

public plugin_init( )
{
	register_plugin( "CS Battle Royale Fake Teams", VERSION, "DoNii" );
	
	new szFilename[ 256 ];
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_MANAGMENT, g_iConfig[ CVARS_FILE ] );
	
	server_cmd( "exec %s", szFilename );
	
	g_iCvars[ 0 ] = register_cvar( "csbr_team_num", "32" ); // number of teams
	g_iCvars[ 1 ] = register_cvar( "csbr_player_per_team", "1" ); // number of players in one team
	
	g_iMaxTeams = get_pcvar_num( g_iCvars[ 0 ] );
	g_iPlayerPerTeam = get_pcvar_num( g_iCvars[ 1 ] );
	
	if( g_iMaxTeams > MAX_PLAYERS )
	{
		log_amx( "[CSBR] Invalid int value, cannot exceed MAX_PLAYERS value [%d/%d]", g_iMaxTeams, MAX_PLAYERS );
		g_iMaxTeams = MAX_PLAYERS;
	}
	
	if( g_iPlayerPerTeam > MAX_PLAYERS )
	{
		log_amx( "[CSBR] Invalid int value, cannot exceed MAX_PLAYERS value [%d/%d]", g_iPlayerPerTeam, MAX_PLAYERS );
		g_iPlayerPerTeam = MAX_PLAYERS;
	}
	
	if( ( g_iMaxTeams * g_iPlayerPerTeam ) > MAX_PLAYERS )
	{
		log_amx( "[CSBR] Invalid value, maxteams * player per team can't exceed max players [%d/%d]", g_iMaxTeams * g_iPlayerPerTeam, MAX_PLAYERS );
		
		g_iMaxTeams = MAX_PLAYERS;
		g_iPlayerPerTeam = 1;
	}
	
	RegisterHam( Ham_Spawn, "player", "@HamSpawn_Pre", 0 );
	
	g_iHamTakeDamageFw = RegisterHam( Ham_TakeDamage, "player", "fw_HamTakeDamagePre", 0 );
	DisableHamForward( g_iHamTakeDamageFw );
	
	g_iHamTraceAttackFw = RegisterHam( Ham_TraceAttack, "player", "fw_HamTraceAttackPre", 0 );
	DisableHamForward( g_iHamTraceAttackFw );
	
	g_iHamKilledFw = RegisterHam( Ham_Killed, "player", "fw_HamKilledPre", 0 );
	DisableHamForward( g_iHamKilledFw );
	
	g_iFwAssignTeam = CreateMultiForward( "PlayerAssignTeam", ET_IGNORE, FP_CELL, FP_CELL );
}

public plugin_precache( )
{
	get_configsdir( g_szConfigsDir, charsmax( g_szConfigsDir ) );

	ReadConfig( );
}

public plugin_cfg( )
{
	EnableHamForward( g_iHamTakeDamageFw );
	EnableHamForward( g_iHamTraceAttackFw );
	EnableHamForward( g_iHamKilledFw );
}

public plugin_natives( )
{
	register_library( "cs_battleroyale_faketeams" );

	register_native( "GetPlayerTeam", "OnNativeGetPlayerTeam", 1 );
	register_native( "SetPlayerTeam", "OnNativeSetPlayerTeam", 1 );
	register_native( "GetMaxTeams", "OnNativeGetMaxTeams", 1 );
	register_native( "SetMaxTeams", "OnNativeSetMaxTeams", 1 );
	register_native( "GetPlayerPerTeam", "OnNativeGetPlayerPerTeam", 1 );
	register_native( "SetPlayerPerTeam", "OnNativeSetPlayerPerTeam", 1 );
	register_native( "GetPlayersInTeam", "OnNativeGetPlayersInTeam", 1 );
	register_native( "SetPlayersInTeam", "OnNativeSetPlayersInTeam", 1 );
	register_native( "FindAvailableTeam", "OnNativeFindTeam", 1 );
}

public OnNativeFindTeam( )
{
	return FindAvailableTeam( );
}

public OnNativeGetPlayersInTeam( iTeam )
{
	if( ! ( 1 <= iTeam <= MAX_PLAYERS ) )
	{
		return -1;
	}

	return g_iPlayersInTeam[ iTeam ];
}

public OnNativeSetPlayersInTeam( iTeam, iValue )
{
	if( ! ( 1 <= iTeam <= MAX_PLAYERS ) )
	{
		return -1;
	}
	
	g_iPlayersInTeam[ iTeam ] = iValue;
	return 1;
}

public OnNativeGetPlayerTeam( id )
{
	if( ! is_user_connected( id ) )
	{
		return -1;
	}
	
	return g_iPlayerTeam[ id ];
}

public OnNativeSetPlayerTeam( id, iTeam )
{
	if( ! is_user_connected( id ) )
	{
		return -1;
	}

	if( g_iPlayersInTeam[ iTeam ] >= g_iPlayerPerTeam )
	{
		log_amx( "[CSBR] Invalid team, can't exceed Max team num" );
		return -1;
	}
	
	g_iPlayerTeam[ id ] = iTeam;
	return 1;
}

public OnNativeGetMaxTeams( )
{
	return g_iMaxTeams;
}

public OnNativeSetMaxTeams( iValue )
{
	if( !( 1 <= iValue <= MAX_PLAYERS ) )
	{
		log_amx( "[CSBR] Invalid Num, must be in-between 1-MaxPlayers" );
		return -1;
	}

	g_iMaxTeams = iValue;
	return 1;
}

public OnNativeGetPlayerPerTeam( )
{
	return g_iPlayerPerTeam;
}

public OnNativeSetPlayerPerTeam( iValue )
{
	if( !( 1 <= iValue <= MAX_PLAYERS ) )
	{
		log_amx( "[CSBR] Invalid Num, must be in-between 1-MaxPlayers" );
		return -1;
	}

	g_iPlayerPerTeam = iValue;
	return 1;
}

@HamSpawn_Pre( id )
{
	if( g_iPlayerTeam[ id ] == NO_TEAM )
	{
		new szName[ 32 ];
		get_user_name( id, szName, charsmax( szName ) );
		
		new iFindTeam = FindAvailableTeam( );

		if( iFindTeam > NO_TEAM )
		{
			g_iPlayersInTeam[ iFindTeam ]++;	
			g_iPlayerTeam[ id ] = iFindTeam;
			
			ExecuteForward( g_iFwAssignTeam, g_iDummyResult, id, iFindTeam );	
		}
		
		else
		{
			if( ! get_pdata_bool( id, m_bJustConnected ) )
			{
				set_pdata_int( id, m_iNumRespawns, 1 );
				return HAM_SUPERCEDE;
			}
		}
	}
	return HAM_IGNORED;
}

public fw_HamKilledPre( iVictim, iAttacker, iShouldGib )
{
	if( iVictim == iAttacker || ! is_user_connected( iVictim ) || ! is_user_connected( iAttacker ) )
	{
		return HAM_IGNORED;
	}
	
	new iVictimTeam = get_user_team( iVictim );
	
	if( g_iPlayerTeam[ iVictim ] != g_iPlayerTeam[ iAttacker ] )
	{
		if( iVictimTeam == get_user_team( iAttacker ) )
		{
			cs_set_user_team( iVictim, iVictimTeam == 1 ? 2 : 1 );
		}
	}
	return HAM_IGNORED;
}

public fw_HamTraceAttackPre( iVictim, iAttacker, Float:fDamage, Float:fDir[ 3 ], iPtr, iDamageType )
{
	if( ( iVictim == iAttacker ) || ! is_user_connected( iVictim ) || ! is_user_connected( iAttacker ) )
	{
		return HAM_IGNORED;
	}

	new iVictimTeam = get_user_team( iVictim );
	
	if( g_iPlayerTeam[ iVictim ] != g_iPlayerTeam[ iAttacker ] )
	{
		if( iVictimTeam == get_user_team( iAttacker ) )
		{
			cs_set_user_team( iVictim, iVictimTeam == 1 ? 2 : 1 );
			ExecuteHamB( Ham_TraceAttack, iVictim, iAttacker, fDamage, fDir, iPtr, iDamageType );
			cs_set_user_team( iVictim, iVictimTeam );
			
			return HAM_SUPERCEDE;
		}
		return HAM_IGNORED;
	}
	SetHamParamFloat( 3, 0.0 );
	return HAM_SUPERCEDE;
}

public fw_HamTakeDamagePre( iVictim, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{	
	if( iVictim == iAttacker || ! is_user_connected( iVictim ) || ! is_user_connected( iAttacker ) )
	{
		return HAM_IGNORED;
	}
	
	new iVictimTeam = get_user_team( iVictim );
	
	if( g_iPlayerTeam[ iVictim ] != g_iPlayerTeam[ iAttacker ] )
	{
		if( iVictimTeam == get_user_team( iAttacker ) )
		{
			cs_set_user_team( iVictim, iVictimTeam == 1 ? 2 : 1 );
			ExecuteHamB( Ham_TakeDamage, iVictim, iInflictor, iAttacker, fDamage, iDamageBits );
			cs_set_user_team( iVictim, iVictimTeam );
			
			return HAM_SUPERCEDE;
		}
		return HAM_IGNORED;
	}
	SetHamParamFloat( 4, 0.0 );
	return HAM_SUPERCEDE;
}

ReadConfig( )
{
	new szFilename[ 256 ];	
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_MANAGMENT, CSBR_Config_File );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{
		new szData[ 128 ], szValue[ 32 ], szKey[ 32 ];
		
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{
			trim( szData );
			
			remove_quotes( szKey );
			remove_quotes( szValue );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/':
				{
					continue;
				}
				
			default:
				{
					strtok( szData, szKey, charsmax( szKey ), szValue, charsmax( szValue ), '=' );
					
					trim( szKey ); 
					trim( szValue );
					
					remove_quotes( szKey );
					remove_quotes( szValue );
					
					if( ! szValue[ 0 ] )
					{
						continue;
					}
					
					if( equal( szKey, "CVARS_FILE" ) )
					{
						g_iConfig[ CVARS_FILE ] = szValue;
					}
				}
			}
		}
	}
	fclose( iFile );
}

FindAvailableTeam( )
{
	new iFoundTeam;

	for( new iTeam = 1 ; iTeam <= g_iMaxTeams; iTeam++ )
	{
		if( IsTeamAvailable( iTeam ) )
		{	
			iFoundTeam = iTeam;
			break;
		}
	}
	
	return iFoundTeam;
}

IsTeamAvailable( iTeam )
{
	return g_iPlayersInTeam[ iTeam ] < g_iPlayerPerTeam ? 1 : 0;
}

stock bool:get_pdata_bool(ent, charbased_offset, intbase_linuxdiff = 5) 
{ 
	return !!( get_pdata_int(ent, charbased_offset / INT_BYTES, intbase_linuxdiff) & (0xFF<<((charbased_offset % INT_BYTES) * BYTE_BITS)) ) 
} 