#include < amxmodx >
#include < amxmisc >
#include < fakemeta >
#include < engine >
#include < xs >
#include < fun >
#include < csbr_config >

#define ADD_FLAG ADMIN_RCON

enum ( += 9521 )
{
	TASK_CHECK_PLAYERS,
	TASK_RENEW_SPHERE,
	TASK_TIGHTEN_ZONE
}

enum _:ZoneData
{
Float:ZoneOrigins[ 3 ]
}

enum _:Config
{
	ZONE_ORIGINS_FILE[ 32 ]
}

new const g_szSprite[ ] = "sprites/laserbeam.spr";

new const g_szZoneCmds[ ][ ] =
{
	"say /zone_origins",
	"say /zo"
}

new g_iConfig[ Config ];

new g_iSprite;
new g_iDummyResult;

new g_iFwRedZoneAppear;

new g_iCvars[ 5 ];

new Float:g_fRadius;
new Float:g_fZoneOrigin[ 3 ];

new Array:g_aZoneOrigins;

new g_szMapName[ 32 ];
new g_szConfigsDir[ 128 ];

public plugin_init( )
{
	register_plugin( "CS Battle Royale Red Zone", VERSION, "DoNii" );

	register_dictionary( "cs_battleroyale.txt" );
	
	for( new i; i < sizeof g_szZoneCmds; i++ )
	register_clcmd( g_szZoneCmds[ i ], "OnZoneAddDirection" );
	
	g_iCvars[ 0 ] = register_cvar( "csbr_redzone_start_time", "60.0" );
	g_iCvars[ 1 ] = register_cvar( "csbr_redzone_tighten_start", "120.0" );
	g_iCvars[ 2 ] = register_cvar( "csbr_redzone_radius", "2000.0" );
	g_iCvars[ 3 ] = register_cvar( "csbr_redzone_renew_freq", "0.5" );
	g_iCvars[ 4 ] = register_cvar( "csbr_redzone_check_players", "2.0" );
	
	register_logevent( "OnNewRound", 2, "1=Round_Start" );
	
	g_iFwRedZoneAppear = CreateMultiForward( "RedZoneAppear", ET_IGNORE );
}

public plugin_precache( ) 
{ 
	g_aZoneOrigins = ArrayCreate( ZoneData );

	get_mapname( g_szMapName, charsmax( g_szMapName ) );
	get_configsdir( g_szConfigsDir, charsmax( g_szConfigsDir ) )
	
	ReadConfig( );
	ReadZoneOrigins( );
	
	g_iSprite = precache_model( g_szSprite );
} 

public RoundEnded( )
{
	remove_task( TASK_CHECK_PLAYERS );
	remove_task( TASK_RENEW_SPHERE );
	remove_task( TASK_TIGHTEN_ZONE );
}

public OnNewRound( )
{
	remove_task( TASK_CHECK_PLAYERS );
	remove_task( TASK_RENEW_SPHERE );
	remove_task( TASK_TIGHTEN_ZONE );
	
	g_fRadius = get_pcvar_float( g_iCvars[ 2 ] );
	
	if( GetRandomZoneOrigin( g_fZoneOrigin ) == -1 )
	{
		log_amx( "[CSBR] No Zone Origins Found" );
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public RoundStarted( )
{
	set_task( get_pcvar_float( g_iCvars[ 0 ] ), "OnActivateRedZone" );
	
	client_print( 0, print_center, "%L", LANG_PLAYER, "ZONE_APPEARS", floatround( get_pcvar_float( g_iCvars[ 0 ] ) ) );
}

public OnZoneAddDirection( id )
{
	if( ~ get_user_flags( id ) & ADD_FLAG )
	return PLUGIN_HANDLED;
	
	new iMenu = menu_create( "Menu to Add new Zone directions", "OnZoneAddDirection_Handler" );
	
	new szItem[ 64 ], Float:fOrigin[ 3 ];
	pev( id, pev_origin, fOrigin );
	formatex( szItem, charsmax( szItem ), "Add Current Location (%.1f %.1f %.1f)", fOrigin[ 0 ], fOrigin[ 1 ], fOrigin[ 2 ] );
	
	menu_additem( iMenu, szItem, _, _ );
	menu_setprop( iMenu, MPROP_EXIT, MEXIT_ALL );
	
	menu_display( id, iMenu, 0 );
	return PLUGIN_CONTINUE;
}

public OnZoneAddDirection_Handler( id, iMenu, iItem )
{
	if( iItem == 0 )
	{
		new Float:fOrigin[ 3 ], szOrigin[ 32 ];
		pev( id, pev_origin, fOrigin );

		formatex( szOrigin, charsmax( szOrigin ), "%.1f %.1f %.1f", fOrigin[ 0 ], fOrigin[ 1 ], fOrigin[ 2 ] );
		
		if( WriteToFile( szOrigin ) == -1 )
		{
			log_amx( "[CSBR] Zone To Write New Origins could not be found" );
			return PLUGIN_HANDLED;
		}
	}
	menu_destroy( iMenu );
	return PLUGIN_HANDLED;
}

public OnActivateRedZone( )
{
	ExecuteForward( g_iFwRedZoneAppear, g_iDummyResult );

	set_task( get_pcvar_float( g_iCvars[ 3 ] ), "KeepRenewingSphere", TASK_RENEW_SPHERE, .flags="b" ); // keep renewing the zone (0.1 will overflow)
	set_task( get_pcvar_float( g_iCvars[ 4 ] ), "CheckPlayerOutsideArea", TASK_CHECK_PLAYERS, .flags="b" ); // check for players outside the zone
	set_task( get_pcvar_float( g_iCvars[ 1 ] ), "OnStartTighteningZone", TASK_TIGHTEN_ZONE, .flags="b" ); // start to tighten the zone (make it smaller)
}

public OnStartTighteningZone( )
{
	g_fRadius /= 2.0; // start reducing the radius
	
	client_print( 0, print_center, "%L", LANG_PLAYER, "ZONE_TIGHTEN" );
}

public KeepRenewingSphere( )
{
	const iDivides = 128; // cant go more than that
	new Float:fOrigin[ 3 ], Float:fAngle[ 3 ], Float:AngleMulScalar = ( 360.0 / iDivides ), Float:fVector[ 3 ];
	
	for( new i; i < iDivides; i++ )
	{
		angle_vector( fAngle, ANGLEVECTOR_RIGHT, fVector );
		xs_vec_mul_scalar( fVector, g_fRadius, fVector );
		xs_vec_add( g_fZoneOrigin, fVector, fOrigin );
		
		CreateBeam( fOrigin );

		fAngle[ 1 ] += AngleMulScalar;
	}
}

public CheckPlayerOutsideArea( )
{
	new Float:fPlayerOrigin[ 3 ];

	new iEnt = -1;
	while( ( iEnt = find_ent_by_class( iEnt, "player" ) ) != 0 )
	{
		pev( iEnt, pev_origin, fPlayerOrigin );
		
		fPlayerOrigin[ 0 ] -= g_fZoneOrigin[ 0 ];
		fPlayerOrigin[ 1 ] -= g_fZoneOrigin[ 1 ];

		if( Length2D( fPlayerOrigin ) > g_fRadius )
		{
			if( is_user_alive( iEnt ) ) // prevents error
			{
				set_user_health( iEnt, get_user_health( iEnt ) - random_num( 1, 10 ) ); // using this instead of pev_health because this deals with Kill when Hp is 0
				client_cmd( iEnt, "spk sound/player/bhit_flesh-1.wav" );
			}
		}
	}
}

Float:Length2D( Float:Origin[ 3 ] )
{
	return floatsqroot( Origin[ 0 ] * Origin[ 0 ] + Origin[ 1 ] * Origin[ 1 ] );
}

GetRandomZoneOrigin( Float:fOutput[ 3 ] )
{
	new iArraySize = ArraySize( g_aZoneOrigins );

	if( ! iArraySize )
	return -1;
	
	new eData[ ZoneData ];
	
	new iEntry = random_num( 0, iArraySize - 1 );
	ArrayGetArray( g_aZoneOrigins, iEntry, eData );
	
	for( new i = 0; i < 3; i++ )
	{
		fOutput[ i ] = eData[ ZoneOrigins ][ i ];
	}
	return 1;
}

CreateBeam( Float:fOrigin[ 3 ] )
{  
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( TE_BEAMPOINTS )
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] )
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] )
	engfunc( EngFunc_WriteCoord, fOrigin[ 2 ] )
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] )
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] )
	engfunc( EngFunc_WriteCoord, 4000.0 )
	write_short( g_iSprite ) 
	write_byte( 1 ) 
	write_byte( 5 ) 
	write_byte( 10 ) 
	write_byte( 50 ) 
	write_byte( 0 ) 
	write_byte( 255 )
	write_byte( 0 )
	write_byte( 0 )
	write_byte( 128 )
	write_byte( 1 )
	message_end( );
}

ReadConfig( )
{
	new szFilename[ 256 ];
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s", g_szConfigsDir, PATH_MANAGMENT, CSBR_Config_File );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{
		new szData[ 128 ], szValue[ 32 ], szKey[ 32 ];
		
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{
			trim( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/': 
				continue;
				
			default:
				{
					strtok( szData, szKey, charsmax( szKey ), szValue, charsmax( szValue ), '=' );
					
					trim( szKey ); 
					trim( szValue );					
					
					remove_quotes( szKey );
					remove_quotes( szValue );
					
					if( equal( szKey, "ZONE_ORIGINS_FILE" ) )
					{
						g_iConfig[ ZONE_ORIGINS_FILE ] = szValue;
					}
				}
			}
		}
		fclose( iFile );
	}
}

ReadZoneOrigins( )
{
	if( ! g_iConfig[ ZONE_ORIGINS_FILE ][ 0 ] )
	{
		log_amx( "[CSBR] Zone Origins File Not Found" );
		return PLUGIN_HANDLED;
	}
	
	new szFilename[ 256 ], szData[ 32 ], szOrigin1[ 10 ], szOrigin2[ 10 ], szOrigin3[ 10 ], eData[ ZoneData ];
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ ZONE_ORIGINS_FILE ] );
	
	new iFile = fopen( szFilename, "rt" );
	
	if( iFile )
	{			
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{		
			trim( szData );
			
			if( parse( szData, szOrigin1, charsmax( szOrigin1 ), szOrigin2, charsmax( szOrigin2 ), szOrigin3, charsmax( szOrigin3 ) ) < 3 )
			continue;

			eData[ ZoneOrigins ][ 0 ] = _:str_to_float( szOrigin1 );
			eData[ ZoneOrigins ][ 1 ] = _:str_to_float( szOrigin2 );
			eData[ ZoneOrigins ][ 2 ] = _:str_to_float( szOrigin3 );
			
			ArrayPushArray( g_aZoneOrigins, eData );
		}
		fclose( iFile );
	}
	return PLUGIN_CONTINUE;
}

WriteToFile( const szString[ ] )
{
	new szFilename[ 256 ];	
	formatex( szFilename, charsmax( szFilename ), "%s/%s/%s/%s", g_szConfigsDir, PATH_POINTS, g_szMapName, g_iConfig[ ZONE_ORIGINS_FILE ] );
	
	new iFile = fopen( szFilename, "at" );
	
	if( ! iFile )
	return -1;
	
	new szLine[ 32 ];
	formatex( szLine, charsmax( szLine ), "^n%s", szString );
	
	fputs( iFile, szLine );
	
	fclose( iFile );
	return 1;
}