#include < amxmodx >
#include < cstrike >
#include < hamsandwich >
#include < fakemeta >
#include < engine >
#include < nvault >
#include < orpheu >
#include < orpheu_stocks >
#include < nvault >
#include < nvault_util >
#include < nvault_array >
#include < csbr_config >
#include < cs_battleroyale_faketeams >

#define SHORT_BYTES    2 
#define INT_BYTES        4 
#define BYTE_BITS        8 

#define MOTD_FLAG_ARG 1
#define MOTD_FLAG_END 1

#define DMG_HEGRENADE    (1 << 24)

#if !defined CSW_GLOCK
#define CSW_GLOCK 2
#endif

//Allocate additional memory to plugin to prevent stack error
#pragma dynamic 16384

enum _:Tasks ( += 8260 )
{
	TASK_1,
	TASK_2,
	TASK_3,
	TASK_DISCONNECT
};

enum _:PlayerStats
{
	Player_Wins,
	Player_Kills,
	Player_HeadShots,
Float:Player_Damage
};

new g_iSyncHudObject;
new g_iTime;
new g_iDummyResult;
new g_iVault;

new g_iFwRoundStart;
new g_iFwTeamDead;
new g_iFwRoundWinner;
new g_iFwRoundEnd;

new g_iCvarTimer;
new g_iCvarMinPlayers;
new g_iCvarSvRestart;

new g_pGameRules;

new g_iPlayerStats[ MAX_PLAYERS + 1 ][ PlayerStats ];

new bool:g_bHasGameStarted;
new bool:g_bVictoryBlockAttack[ 33 ];
new bool:g_bSawMotd[ 33 ];

const m_LastHitGroup = 75;
const m_iNumRespawns = 365;
const m_bJustConnected = 480;

const g_iSkip = ( 1 << CSW_GLOCK ) | ( 1 << CSW_C4 );

// Old Style Menus
stock const FIRST_JOIN_MSG[ ]       =   "#Team_Select";
stock const FIRST_JOIN_MSG_SPEC[ ]  =	"#Team_Select_Spect";
stock const INGAME_JOIN_MSG[ ]      =	"#IG_Team_Select";
stock const INGAME_JOIN_MSG_SPEC[ ] =	"#IG_Team_Select_Spect";

const iMaxLen = sizeof( INGAME_JOIN_MSG_SPEC );

const m_pPlayer = 41;

// New VGUI Menus
const VGUI_JOIN_TEAM_NUM = 2;

public plugin_precache( )
{
	OrpheuRegisterHook( OrpheuGetFunction( "InstallGameRules" ), "OnInstallGameRules", OrpheuHookPost );
}

public plugin_init( )
{
	register_plugin( "CS Battle Royale Round Manager", VERSION, "DoNii" );
	
	g_iVault = nvault_open( "csbr_stats" );
	
	if( g_iVault == INVALID_HANDLE )
	{
		set_fail_state( "Error opening nVault" );
	}
	
	register_dictionary( "cs_battleroyale.txt" );
	
	OrpheuRegisterHookFromObject( g_pGameRules, "FPlayerCanRespawn", "CGameRules", "OnFPlayerCanRespawn" );  
	
	register_message( get_user_msgid( "ShowMenu" ), "MsgShowMenu" );
	register_message( get_user_msgid( "VGUIMenu" ), "MsgVGUIMenu" );
	register_message( get_user_msgid( "MOTD" ),     "MsgMotd"     );
	
	g_iFwRoundStart  = CreateMultiForward( "RoundStarted", ET_IGNORE                   );
	g_iFwTeamDead    = CreateMultiForward( "TeamDead",     ET_IGNORE, FP_CELL, FP_CELL );
	g_iFwRoundWinner = CreateMultiForward( "RoundWinner",  ET_IGNORE, FP_CELL          );
	g_iFwRoundEnd    = CreateMultiForward( "RoundEnded",   ET_IGNORE                   )
	
	g_iSyncHudObject = CreateHudSyncObj( );
	
	g_iCvarTimer = register_cvar( "csbr_round_timer", "15" );
	g_iCvarMinPlayers = register_cvar( "csbr_min_players", "2" );
	
	g_iCvarSvRestart = get_cvar_pointer( "sv_restartround" );
	
	register_logevent( "OnNewRound", 2, "1=Round_Start" );
	
	RegisterHam( Ham_Killed, "player", "@HamKilled_Post", 1 );
	RegisterHam( Ham_TakeDamage, "player", "@HamTakeDamage_Pre", 0 );
	RegisterHam( Ham_Spawn, "player", "@HamSpawn_Pre", 0 );
	
	new szWeaponName[ 32 ];
	for( new i = CSW_P228; i <= CSW_P90; i++ )
	{
		if( g_iSkip & ( 1 << i ) )
		{
			continue;
		}
		
		get_weaponname( i, szWeaponName, charsmax( szWeaponName ) );
		RegisterHam( Ham_Weapon_PrimaryAttack, szWeaponName, "@HamPrimaryAttack_Pre" );
	}
}

public plugin_natives( )
{
	register_library( "cs_battleroyale_roundmanager" );

	register_native( "HasGameStarted", "OnNativeHasGameStarted", 1 );
	register_native( "IsLastTeam", "OnNativeIsLastTeam", 1 );
	register_native( "GetTeamAlivePlayers", "OnNativeGetTeamAlivePlayers", 1 );
	register_native( "GetRemainingTeams", "OnNativeGetRemainingTeams", 1 );
}

public plugin_end( )
{
	nvault_close( g_iVault );
}

public MsgVGUIMenu( iMsgId, iDest, id )
{
	if( get_msg_arg_int( 1 ) != VGUI_JOIN_TEAM_NUM )
	{
		return PLUGIN_CONTINUE;
	}
	
	if( 1 <= get_user_team( id ) <= 2 || is_user_bot( id ) )
	{
		return PLUGIN_HANDLED;
	}
	
	new szParameters[ 2 ];
	szParameters[ 0 ] = id;
	szParameters[ 1 ] = iMsgId;
	
	set_task( 0.1, "OnAutoJoin", _, szParameters, sizeof( szParameters ) );
	
	return PLUGIN_HANDLED;
}

public MsgShowMenu( iMsgId, iDest, id )
{
	if( 1 <= get_user_team( id ) <= 2 || is_user_bot( id ) )
	{
		return PLUGIN_HANDLED;
	}

	static szMenuCode[ iMaxLen ];
	get_msg_arg_string( 4, szMenuCode, charsmax( szMenuCode ) );
	
	if( equal( szMenuCode, FIRST_JOIN_MSG ) || equal( szMenuCode, FIRST_JOIN_MSG_SPEC ) )
	{
		new szParameters[ 2 ];
		szParameters[ 0 ] = id;
		szParameters[ 1 ] = iMsgId;
		
		set_task( 0.1, "OnAutoJoin", _, szParameters, sizeof( szParameters ) );
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_HANDLED;
}

public OnAutoJoin( const szParameters[ ] )
{
	new id = szParameters[ 0 ];
	new iMsgId = szParameters[ 1 ];
	
	new iMsgBlock = get_msg_block( iMsgId );
	set_msg_block( iMsgId, BLOCK_SET );
	
	new iTeam = random_num( 1, 2 );
	new iClass = random_num( 1, 5 );
	
	new szClass[ 2 ], szTeam[ 2 ];
	num_to_str( iTeam, szTeam, charsmax( szTeam ) );
	num_to_str( iClass, szClass, charsmax( szClass ) );
	
	engclient_cmd( id, "jointeam", szTeam );
	engclient_cmd( id, "joinclass", szClass );
	
	set_msg_block( iMsgId, iMsgBlock );
}

public client_connect( id )
{
	ResetStats( id );

	g_bSawMotd[ id ] = false;
}

@HamSpawn_Pre( id )
{
	if( g_bHasGameStarted )
	{
		if( ! get_pdata_bool( id, m_bJustConnected ) )
		{
			set_pdata_int( id, m_iNumRespawns, 1 ); 
		}
	}
}

public MsgMotd( iMsgId, iDest, id )
{
	if( ! g_bSawMotd[ id ] )
	{
		if( get_msg_arg_int( MOTD_FLAG_ARG ) == MOTD_FLAG_END )
		{
			g_bSawMotd[ id ] = true;
		}
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public OnInstallGameRules( )  
{ 
	g_pGameRules = OrpheuGetReturn( );  
}

public OrpheuHookReturn:OnFPlayerCanRespawn( pGameRules, id )  
{  
	if( g_bHasGameStarted )
	{		
		OrpheuSetReturn( false )  
		return OrpheuOverride;
	}
	
	else if( GetPlayerTeam( id ) == NO_TEAM )
	{
		if( FindAvailableTeam( ) <= 0 )
		{			
			OrpheuSetReturn( false )  
			return OrpheuOverride;
		}
	}
	return OrpheuIgnored;
}

@HamTakeDamage_Pre( iVictim, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{
	if( ! g_bHasGameStarted )
	{
		return HAM_SUPERCEDE;
	}
	
	if( ! is_user_connected( iAttacker ) )
	{
		return HAM_IGNORED;
	}
	
	if( ( iDamageBits & DMG_BULLET ) || ( iDamageBits & DMG_HEGRENADE ) )
	{
		g_iPlayerStats[ iAttacker ][ Player_Damage ] += fDamage;
		
		if( get_pdata_int( iVictim, m_LastHitGroup ) == HIT_HEAD )
		{
			g_iPlayerStats[ iAttacker ][ Player_HeadShots ]++;
		}
	}
	return HAM_IGNORED;
}

@HamPrimaryAttack_Pre( iEnt )
{	
	new id = get_pdata_cbase( iEnt, m_pPlayer, 4 );
	
	if( g_bVictoryBlockAttack[ id ] )
	{
		const m_bCanShoot = 876/4;
		
		set_pdata_int( id, m_bCanShoot, false );
		return HAM_SUPERCEDE;
	}
	return HAM_IGNORED;
}

public OnNewRound( )
{
	new szPlayers[ 32 ], iNum, iTempID;
	get_players( szPlayers, iNum, "h" );

	for( new i; i < iNum; i++ )
	{
		iTempID = szPlayers[ i ];

		ClearSyncHud( iTempID, g_iSyncHudObject );
		ResetStats( iTempID );
	}

	EnableShooting( );

	g_bHasGameStarted = false;	
	CleanTasks( true, true, true );
	
	g_iTime = get_pcvar_num( g_iCvarTimer );

	if( GetAlivePlayers( ) < get_pcvar_num( g_iCvarMinPlayers ) )
	{		
		set_task( 1.0, "OnTaskFindPlayers", TASK_2, .flags = "b" );
	}
	
	else
	{
		set_task( 1.0, "OnTaskCountDown", TASK_1, .flags = "b" );
	}
}

public OnTaskFindPlayers( )
{		
	if( GetAlivePlayers( ) >= get_pcvar_num( g_iCvarMinPlayers ) )
	{		
		RestartRound( 3 );
		CleanTasks( true, true, true );
	}
}

public OnTaskCountDown( )
{
	if( g_iTime <= 0 )
	{
		g_bHasGameStarted = true;
		ExecuteForward( g_iFwRoundStart, g_iDummyResult );
		
		CleanTasks( true, true, true );
	}
	
	else
	{
		set_hudmessage( 0, 255, 0, 0.35, 0.35, 0, 0.0, 1.1 )
		ShowSyncHudMsg( 0, g_iSyncHudObject, "%L", LANG_PLAYER, "ROUND_STARTS_IN", g_iTime--, ( g_iTime > 1 ) ? "s" : "" );
	}
}

public client_disconnect( id )
{
	new iPlayerTeam = GetPlayerTeam( id );

	if( iPlayerTeam == NO_TEAM )
	{
		return PLUGIN_HANDLED;
	}
	
	set_task( 1.0, "client_disconnect_delayed", id + TASK_DISCONNECT )
	
	SetPlayersInTeam( iPlayerTeam, GetPlayersInTeam( iPlayerTeam ) - 1 );
	SetPlayerTeam( id, NO_TEAM );
	
	return PLUGIN_CONTINUE;
}

public client_disconnect_delayed( id )
{
	id -= TASK_DISCONNECT;
	
	if( g_bHasGameStarted )
	{		
		if( GetRemainingTeams( ) == 1 ) // one team left standing
		{			
			g_bHasGameStarted = false;
			
			Winner_Find( ); // find the winner
			ExecuteForward( g_iFwRoundEnd, g_iDummyResult );
			
			RestartRound( 3 );
		}
		
		else if( GetRemainingTeams( ) <= 0 ) // no teams left, player was playing alone
		{			
			g_bHasGameStarted = false;
			
			ExecuteForward( g_iFwRoundEnd, g_iDummyResult );
			RestartRound( 3 );
		}
	}

	else if( ! g_bHasGameStarted )
	{
		if( GetAlivePlayers( ) < get_pcvar_num( g_iCvarMinPlayers ) )
		{
			client_print( 0, print_center, "Restarting due to insufficient players" );
			RestartRound( 3 );
		}
	}
}

public @HamKilled_Post( iVictim, iAttacker, iShouldGib )
{
	if( g_bHasGameStarted )
	{
		new iRemainingTeams = GetRemainingTeams( );
		
		new szClassName[ 32 ];
		pev( iAttacker, pev_classname, szClassName, charsmax( szClassName ) );
		
		if( iRemainingTeams <= 0 ) // player was playing alone, no teams left alive, the only reason of death must be fall damage or zone
		{
			g_bHasGameStarted = false;
			
			CleanTasks( true, true, true );
			
			ExecuteForward( g_iFwRoundEnd, g_iDummyResult );
			RestartRound( 3 );
			
			// no winner to be announced
		}	
		
		else // otherwise, there is still one or more teams left
		{
			if( GetTeamAlivePlayers( GetPlayerTeam( iVictim ) ) <= 0 ) // all members of the team are dead
			{
				BetterLuckNextTime( iVictim, GetPlayerTeam( iVictim ) ); // better luck to the dead players
			}
			
			if( equal( szClassName, "player" ) && is_user_connected( iAttacker ) ) // attacker is a valid player
			{
				if( IsLastTeam( GetPlayerTeam( iAttacker ) ) ) // is this the last team?
				{					
					g_bHasGameStarted = false;
					
					Winner_Direct( GetPlayerTeam( iAttacker ) ); // we got a winner and we know who it is
					ExecuteForward( g_iFwRoundEnd, g_iDummyResult );
					
					RestartRound( 3 );
				}
				
				if( iVictim != iAttacker ) // didnt kill himself
				{					
					g_iPlayerStats[ iAttacker ][ Player_Kills ]++; // add kill to stats
				}
				
				else if( iVictim == iAttacker ) // killed himself or zone killed him
				{
					if( iRemainingTeams == 1 ) // is there one team left?
					{						
						g_bHasGameStarted = false;
						
						Winner_Find( ); // find the winner
						ExecuteForward( g_iFwRoundEnd, g_iDummyResult );
						
						RestartRound( 3 );
					}
				}
			}
			
			else if( ! equal( szClassName, "player" ) ) // died by fall damage or whatever
			{
				if( iRemainingTeams == 1 ) // is there one team left?
				{					
					g_bHasGameStarted = false;
					
					Winner_Find( ); // find the winner because we don't know who it is
					ExecuteForward( g_iFwRoundEnd, g_iDummyResult );
					
					RestartRound( 3 );
				}
			}
		}
	}
	return HAM_IGNORED;
}

Winner_Find( )
{
	new iWinnerTeam;
	
	new szPlayers[ 32 ], iNum;
	get_players( szPlayers, iNum, "ah" );

	new iTempID;
	for( new i; i < iNum; i++ )
	{
		iTempID = szPlayers[ i ];

		ShowMotdWinner( iTempID );
		g_bVictoryBlockAttack[ iTempID ] = true;
		
		iWinnerTeam = GetPlayerTeam( iTempID );
	}

	iNum = 0;
	iTempID = 0;
	
	arrayset( szPlayers, 0, sizeof( szPlayers ) ); 

	if( GetPlayersInTeam( iWinnerTeam ) > 1 ) // show motd to dead teammates too
	{
		get_players( szPlayers, iNum, "bh" );

		for( new i; i < iNum; i++ )
		{
			iTempID = szPlayers[ i ];

			if( GetPlayerTeam( iTempID ) == iWinnerTeam )
			{
				ShowMotdWinner( iTempID );
				UpdateWins( iTempID );
			}
		}
	}
}

Winner_Direct( iTeam )
{
	ExecuteForward( g_iFwRoundWinner, g_iDummyResult, iTeam );	
	client_print( 0, print_center, "%L", LANG_PLAYER, "ROUND_WINNER", iTeam );
	
	new szPlayers[ 32 ], iNum;
	get_players( szPlayers, iNum, "h" );

	new iTempID;
	for( new i; i < iNum; i++ )
	{
		iTempID = szPlayers[ i ];

		if( GetPlayerTeam( iTempID ) == iTeam )
		{
			ShowMotdWinner( iTempID );
			
			if( is_user_alive( iTempID ) )
			{
				g_bVictoryBlockAttack[ iTempID ] = true;
				UpdateWins( iTempID );
			}
		}
	}
}

ShowMotdWinner( id )
{
	new szMotdInfo[ 512 ], szName[ 32 ];
	get_user_name( id, szName, charsmax( szName ) );

	formatex( szMotdInfo, charsmax( szMotdInfo ), "<body bgcolor=^"black^"><font color=^"white^">Player Name: %s <br>Kills: %d <br>Damage: %.1f <br>Headshots: %d<br>Total Wins: %d<br><img src=^"https://i.imgur.com/bqmjbZB.jpg^" height=^"324^" width=^"324^">", szName, g_iPlayerStats[ id ][ Player_Kills ], g_iPlayerStats[ id ][ Player_Damage ], g_iPlayerStats[ id ][ Player_HeadShots ], GetTotalWins( id ) );
	show_motd( id, szMotdInfo, "Stats" );
	
	ResetStats( id );
}

UpdateWins( id )
{
	new iAuthID[ 35 ], szVaultedWins[ 5 ], szTotalWins[ 5 ];
	get_user_authid( id, iAuthID, charsmax( iAuthID ) );
	
	nvault_get( g_iVault, iAuthID, szVaultedWins );
	
	new iVaultedWins = str_to_num( szVaultedWins );
	new iTotalWins = iVaultedWins + 1;
	
	num_to_str( iTotalWins, szTotalWins, charsmax( szTotalWins ) );
	
	nvault_set( g_iVault, iAuthID, szTotalWins );
}

ShowMotdLoser( id )
{
	new szMotdInfo[ 512 ], szName[ 32 ];
	get_user_name( id, szName, charsmax( szName ) );

	formatex( szMotdInfo, charsmax( szMotdInfo ), "<body bgcolor=^"black^"><font color=^"white^">Player Name: %s <br>Kills: %d <br>Damage: %.1f <br>Headshots: %d", szName, g_iPlayerStats[ id ][ Player_Kills ], g_iPlayerStats[ id ][ Player_Damage ], g_iPlayerStats[ id ][ Player_HeadShots ] );
	show_motd( id, szMotdInfo, "Stats" );
	
	ResetStats( id );
}

GetTotalWins( id )
{
	new iAuthID[ 35 ], szWins[ 5 ];
	get_user_authid( id, iAuthID, charsmax( iAuthID ) );
	
	nvault_get( g_iVault, iAuthID, szWins );
	
	return str_to_num( szWins );
}

GetTeamAlivePlayers( iTeam )
{
	new szPlayers[ 32 ], iNum, iTempID, iCount;
	get_players( szPlayers, iNum, "ah" );
	
	for( new i; i < iNum; i++ )
	{
		iTempID = szPlayers[ i ];
		
		if( GetPlayerTeam( iTempID ) == iTeam )
		{
			iCount++;
		}
	}
	return iCount;
}

bool:IsLastTeam( iTeam )
{
	new bool:bAnnounceWinner;
	
	for( new i = 1; i <= GetMaxTeams( ); i++ )
	{
		if( iTeam == i )
		{
			continue;
		}
		
		if( GetTeamAlivePlayers( i ) <= 0 )
		{
			bAnnounceWinner = true;
			continue;
		}
		
		else
		{
			bAnnounceWinner = false;
			break;
		}
	}
	
	return bAnnounceWinner;
}

GetAlivePlayers( )
{
	new szPlayers[ 32 ], iNum;
	get_players( szPlayers, iNum, "ah" );
	
	return iNum;
}

RestartRound( iTime )
{
	set_pcvar_num( g_iCvarSvRestart, iTime );
}  

BetterLuckNextTime( iPlayer, iTeam )
{	
	ExecuteForward( g_iFwTeamDead, g_iDummyResult, iPlayer, iTeam );
	
	if( GetPlayersInTeam( iTeam ) > 1 ) // has teammates
	{
		new szPlayers[ 32 ], iNum, iTempID;
		get_players( szPlayers, iNum, "bh" );
		
		for( new i; i < iNum; i++ )
		{
			iTempID = szPlayers[ i ];
			
			if( ( GetPlayerTeam( iTempID ) == GetPlayerTeam( iPlayer ) ) )
			{
				client_print( iTempID, print_center, "%L", iTempID, "YOUR_TEAM_PLACED", GetRemainingTeams( ) + 1 );
				ShowMotdLoser( iTempID );
			}
		}
	}
	
	else if( GetPlayerPerTeam( ) == 1 ) // alone
	{
		client_print( iPlayer, print_center, "%L", iPlayer, "YOUR_TEAM_PLACED", GetRemainingTeams( ) + 1 );
		ShowMotdLoser( iPlayer );
	}
}

GetRemainingTeams( )
{
	new iRemainingTeams;

	for( new iTeam = 1; iTeam <= GetMaxTeams( ); iTeam++ )
	{
		if( GetTeamAlivePlayers( iTeam ) >= 1 )
		{
			iRemainingTeams++;
		}
	}
	return iRemainingTeams;
}

ResetStats( id )
{
	g_iPlayerStats[ id ][ Player_Damage ] = _:0.0;
	g_iPlayerStats[ id ][ Player_HeadShots ] = 0;
	g_iPlayerStats[ id ][ Player_Kills ] = 0;
	g_iPlayerStats[ id ][ Player_Wins ] = 0;
}

CleanTasks( bool:Task1=false, bool:Task2=false, bool:Task3=false )
{
	if( Task1 )
	{
		remove_task( TASK_1 );
	}
	
	if( Task2 )
	{
		remove_task( TASK_2 );
	}
	
	if( Task3 )
	{
		remove_task( TASK_3 );
	}
}

EnableShooting( )
{
	new szPlayers[ 32 ], iNum;
	get_players( szPlayers, iNum, "h" );

	new iTempID;
	for( new i; i < iNum; i++ )
	{
		iTempID = szPlayers[ i ];

		g_bVictoryBlockAttack[ iTempID ] = false;
	}
}

public OnNativeHasGameStarted( )
{
	return g_bHasGameStarted;
}

public OnNativeIsLastTeam( iTeam )
{
	return IsLastTeam( iTeam );
}

public OnNativeGetTeamAlivePlayers( iTeam )
{
	return GetTeamAlivePlayers( iTeam );
}

public OnNativeGetRemainingTeams( )
{
	return GetRemainingTeams( );
}

stock bool:get_pdata_bool(ent, charbased_offset, intbase_linuxdiff = 5) 
{ 
	return !!( get_pdata_int(ent, charbased_offset / INT_BYTES, intbase_linuxdiff) & (0xFF<<((charbased_offset % INT_BYTES) * BYTE_BITS)) ) 
} 