#define NO_TEAM 0

/* * * * * * * * * * * * * * * * * * * 
* Returns a Player's Team ID
*
* @param id         Player ID
* @return           Team ID on success, -1 on Invalid Player ID
* * * * * * * * * * * * * * * * * * */
native GetPlayerTeam( id )

/* * * * * * * * * * * * * * * * * * * 
* Sets a Player's Team ID
*
* @param id         Player ID
* @param iTeam      Team ID to set
* @return           1 on success, -1 on Invalid Player ID
* * * * * * * * * * * * * * * * * * */
native SetPlayerTeam( id, iTeam )

/* * * * * * * * * * * * * * * * * * * 
* Returns Max Teams number
*
* @return           Max Teams ID
* * * * * * * * * * * * * * * * * * */
native GetMaxTeams( )

/* * * * * * * * * * * * * * * * * * * 
* Sets Max Teams number
*
* @param iValue     Value to set
* @return           1 on success, -1 on Invalid Number (1-MaxPlayers)
* * * * * * * * * * * * * * * * * * */
native SetMaxTeams( iValue )

/* * * * * * * * * * * * * * * * * * * 
* Gets number of players in a specified team.
*
* @param iTeam     Which team
* @return          Team on success, -1 on Invalid Team (1-MaxPlayers)
* * * * * * * * * * * * * * * * * * */
native GetPlayersInTeam( iTeam )

/* * * * * * * * * * * * * * * * * * * 
* Sets number of players in a specified team.
*
* @param iTeam     Which team
* @param iValue    Value to set
*
* @return          1 on success, -1 on Invalid Team (1-MaxPlayers)
* * * * * * * * * * * * * * * * * * */
native SetPlayersInTeam( iTeam, iValue )

/* * * * * * * * * * * * * * * * * * * 
* Returns number of Players in one Team
*
* @return           Number of Players
* * * * * * * * * * * * * * * * * * */
native GetPlayerPerTeam( )


/* * * * * * * * * * * * * * * * * * * 
* Sets number of Players in one Team
*
* @param iValue     Number of players
* @return           1 on success, -1 on Invalid Number (1-MaxPlayers)
* * * * * * * * * * * * * * * * * * */
native SetPlayerPerTeam( iValue )

/* * * * * * * * * * * * * * * * * * * 
* Searches for an available team.
*
* @return           Team (0 if not found, 1-MAX_PLAYERS if found)
* * * * * * * * * * * * * * * * * * */
native FindAvailableTeam( )

/* * * * * * * * * * * * * * * * * * * * * * *
* Forward called when Player is assigned a team.
*
* @param id       Player who got assigned a team.
* @param iTeam     Team that he got assigned
* * * * * * * * * * * * * * * * * * * * * * * */
forward PlayerAssignTeam( id, iTeam )